Package: gridtext
Type: Package
Title: Improved Text Rendering Support for 'Grid' Graphics
Version: 0.1.6
Authors@R: 
    c(
      person(
        given = "Claus O.",
        family = "Wilke",
        role = c("aut"),
        email = "wilke@austin.utexas.edu",
        comment = c(ORCID = "0000-0002-7470-9261")
      ),
      person(
        given = "Brenton M.",
        family = "Wiernik",
        role = c("aut", "cre"),
        email = "brenton@wiernik.org",
        comment = c(ORCID = "0000-0001-9560-6336", Twitter = "@bmwiernik")
      )
    )
Description: Provides support for rendering of formatted text using 'grid' graphics. Text can be
    formatted via a minimal subset of 'Markdown', 'HTML', and inline 'CSS' directives, and it can be
    rendered both with and without word wrap.
URL: https://wilkelab.org/gridtext/
BugReports: https://github.com/wilkelab/gridtext/issues
License: MIT + file LICENSE
Depends: R (>= 3.5)
Imports: curl, grid, grDevices, markdown, rlang, Rcpp, png, jpeg,
        stringr, xml2
Suggests: covr, knitr, rmarkdown, testthat, vdiffr
LinkingTo: Rcpp
Encoding: UTF-8
RoxygenNote: 7.1.1
NeedsCompilation: yes
Packaged: 2026-02-18 22:56:00 UTC; brentonw
Author: Claus O. Wilke [aut] (ORCID: <https://orcid.org/0000-0002-7470-9261>),
  Brenton M. Wiernik [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-9560-6336>, Twitter: @bmwiernik)
Maintainer: Brenton M. Wiernik <brenton@wiernik.org>
Repository: CRAN
Date/Publication: 2026-02-19 06:10:21 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-27 21:30:37 UTC; unix
Archs: gridtext.so.dSYM

Package: gridtext
Type: Package
Title: Improved Text Rendering Support for 'Grid' Graphics
Version: 0.1.6
Authors@R: 
    c(
      person(
        given = "Claus O.",
        family = "Wilke",
        role = c("aut"),
        email = "wilke@austin.utexas.edu",
        comment = c(ORCID = "0000-0002-7470-9261")
      ),
      person(
        given = "Brenton M.",
        family = "Wiernik",
        role = c("aut", "cre"),
        email = "brenton@wiernik.org",
        comment = c(ORCID = "0000-0001-9560-6336", Twitter = "@bmwiernik")
      )
    )
Description: Provides support for rendering of formatted text using 'grid' graphics. Text can be
    formatted via a minimal subset of 'Markdown', 'HTML', and inline 'CSS' directives, and it can be
    rendered both with and without word wrap.
URL: https://wilkelab.org/gridtext/
BugReports: https://github.com/wilkelab/gridtext/issues
License: MIT + file LICENSE
Depends: R (>= 3.5)
Imports: curl, grid, grDevices, markdown, rlang, Rcpp, png, jpeg,
        stringr, xml2
Suggests: covr, knitr, rmarkdown, testthat, vdiffr
LinkingTo: Rcpp
Encoding: UTF-8
RoxygenNote: 7.1.1
NeedsCompilation: yes
Packaged: 2026-02-18 22:56:00 UTC; brentonw
Author: Claus O. Wilke [aut] (ORCID: <https://orcid.org/0000-0002-7470-9261>),
  Brenton M. Wiernik [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-9560-6336>, Twitter: @bmwiernik)
Maintainer: Brenton M. Wiernik <brenton@wiernik.org>
Repository: CRAN
Date/Publication: 2026-02-19 06:10:21 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# gridtext

<!-- badges: start -->

[![R build
status](https://github.com/wilkelab/gridtext/workflows/R-CMD-check/badge.svg)](https://github.com/wilkelab/gridtext/actions)
[![Coverage
Status](https://img.shields.io/codecov/c/github/wilkelab/gridtext/master.svg)](https://app.codecov.io/github/wilkelab/gridtext?branch=master)
[![CRAN
status](https://www.r-pkg.org/badges/version/gridtext)](https://cran.r-project.org/package=gridtext)
[![Lifecycle:
maturing](https://img.shields.io/badge/lifecycle-maturing-blue.svg)](https://lifecycle.r-lib.org/articles/stages.html#maturing)
<!-- badges: end -->

Improved text rendering support for grid graphics in R.

## Installation

You can install the current release from CRAN with `install.packages()`:

``` r
install.packages("gridtext")
```

To install the latest development version of this package, please run
the following line in your R console:

``` r
remotes::install_github("wilkelab/gridtext")
```

## Examples

The gridtext package provides two new grobs, `richtext_grob()` and
`textbox_grob()`, which support drawing of formatted text labels and
formatted text boxes, respectively. Both grobs understand an extremely
limited subset of Markdown, HTML, and CSS directives. The idea is to
provide a minimally useful subset of features. These currently include
italics, bold, super- and subscript, as well as changing text color,
font, and font size via inline CSS. Extremely limited support for images
is also provided.

Note that all text rendering is performed through a custom-built
rendering pipeline that is part of the gridtext package. This approach
has several advantages, including minimal dependencies, good
performance, and compatibility with all R graphics devices (to the
extent that the graphics devices support the fonts you want to use). The
downside of this approach is the severely limited feature set. Don’t
expect this package to support the fancy CSS and javascript tricks
you’re used to when designing web pages.

### Richtext grob

The function `richtext_grob()` serves as a replacement for `textGrob()`.
It is vectorized and can draw multiple text labels with one call. Labels
can be drawn with padding, margins, and at arbitrary angles. Markdown
and HTML parsing is turned on by default.

``` r
library(grid)
library(gridtext)

text <- c(
  "Some text **in bold.**",
  "Linebreaks<br>Linebreaks<br>Linebreaks",
  "*x*<sup>2</sup> + 5*x* + *C*<sub>*i*</sub>",
  "Some <span style='color:blue'>blue text **in bold.**</span><br>And *italics text.*<br>And some <span style='font-size:18pt; color:black'>large</span> text."
)

x <- c(.2, .1, .7, .9)
y <- c(.8, .4, .1, .5)
rot <- c(0, 0, 45, -45)
gp = gpar(
  col = c("black", "red"),
  fontfamily = c("Palatino", "Courier", "Times", "Helvetica")
)
box_gp = gpar(
  col = "black", fill = c(NA, "cornsilk", "lightblue1", NA),
  lty = c(0, 1, 1, 1)
)
hjust <- c(0.5, 0, 0, 1)
vjust <- c(0.5, 1, 0, 0.5)

grid.newpage()
g <- richtext_grob(
  text, x, y, hjust = hjust, vjust = vjust, rot = rot, 
  padding = unit(c(6, 6, 4, 6), "pt"),
  r = unit(c(0, 2, 4, 8), "pt"),
  gp = gp, box_gp = box_gp
)
grid.draw(g)
grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))
```

![](man/figures/README-unnamed-chunk-4-1.png)<!-- -->

The boxes around text labels can be set to have matching widths and/or
heights, and alignment of text inside the box (specified via `hjust` and
`vjust`) is separate from alignment of the box relative to a reference
point (specified via `box_hjust` and `box_vjust`).

``` r
text <- c("January", "February", "March", "April", "May")
x <- (1:5)/6 + 1/24
y <- rep(0.8, 5)
g <- richtext_grob(
  text, x, y, halign = 0, hjust = 1,
  rot = 45,
  padding = unit(c(3, 6, 1, 3), "pt"),
  r = unit(4, "pt"),
  align_widths = TRUE,
  box_gp = gpar(col = "black", fill = "cornsilk")
)
grid.newpage()
grid.draw(g)
grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))
```

![](man/figures/README-unnamed-chunk-5-1.png)<!-- -->

Basic support for images is available as well. As of now, images will
always be vertically aligned with the baseline of the text.

``` r
grid.newpage()

img_src <- system.file("extdata", "Rlogo.png", package = "gridtext")
text <- glue::glue("Image with native aspect ratio: <img src='{img_src}' width='100'/> And some more text.")
grid.draw(richtext_grob(text, x = 0.9, y = 0.7, hjust = 1))

text <- glue::glue("Image with forced size: <img src='{img_src}' width='100' height='30'/> And some more text.")
grid.draw(richtext_grob(text, x = 0.9, y = 0.3, hjust = 1))
```

![](man/figures/README-unnamed-chunk-6-1.png)<!-- -->

### Textbox grob

The function `textbox_grob()` is intended to render multi-line text
labels that require automatic word wrapping. It is similar to
`richtext_grob()`, but there are a few important differences. First,
while `richtext_grob()` is vectorized, `textbox_grob()` is not. It can
draw only a single text box at a time. Second, `textbox_grob()` doesn’t
support rendering the text box at arbitrary angles. Only four different
orientations are supported, corresponding to a rotation by 0, 90, 180,
and 270 degrees.

``` r
g <- textbox_grob(
  "**The quick brown fox jumps over the lazy dog.**<br><br>
  The quick brown fox jumps over the lazy dog.
  The **quick <span style='color:brown;'>brown fox</span>** jumps over the lazy dog.
  The quick brown fox jumps over the lazy dog.",
  x = unit(0.5, "npc"), y = unit(0.7, "npc"),
  gp = gpar(fontsize = 15),
  box_gp = gpar(col = "black", fill = "lightcyan1"),
  r = unit(5, "pt"),
  padding = unit(c(10, 10, 10, 10), "pt"),
  margin = unit(c(0, 10, 0, 10), "pt")
)
grid.newpage()
grid.draw(g)
```

![](man/figures/README-unnamed-chunk-7-1.png)<!-- -->

The alignment parameters `hjust`, `vjust`, `halign`, and `valign`
function just like they do in `richtext_grob()`.

``` r
g <- textbox_grob(
  "**The quick brown fox jumps over the lazy dog.**<br><br>
  The quick brown fox jumps over the lazy dog.
  The **quick <span style='color:brown;'>brown fox</span>** jumps over the lazy dog.
  The quick brown fox jumps over the lazy dog.",
  x = unit(0.2, "npc"), y = unit(0.5, "npc"),
  hjust = 0.5, vjust = 1, halign = 1,
  gp = gpar(fontsize = 15),
  box_gp = gpar(col = "black", fill = "lightcyan1"),
  r = unit(5, "pt"),
  padding = unit(c(10, 10, 10, 10), "pt"),
  margin = unit(c(0, 10, 0, 10), "pt"),
  orientation = "left-rotated"
)
grid.newpage()
grid.draw(g)
```

![](man/figures/README-unnamed-chunk-8-1.png)<!-- -->

## Acknowledgments

This project received [financial
support](https://r-consortium.org/all-projects/2018-group-2.html#next-generation-text-layout-in-grid-and-ggplot2) from
the [R consortium.](https://r-consortium.org/)

<img src="https://r-consortium.org/images/RConsortium_Horizontal_Pantone.webp" width="250">

#' Draw formatted text labels
#'
#' This grob acts mostly as a drop-in replacement for [`grid::textGrob()`]
#' but provides more sophisticated formatting. The grob can handle basic
#' markdown and HTML formatting directives, and it can also draw
#' boxes around each piece of text. Note that this grob **does not** draw
#' [plotmath] expressions.
#'
#' @param text Character vector containing Markdown/HTML strings to draw.
#' @param x,y Unit objects specifying the location of the reference point.
#' @param hjust,vjust Numerical values specifying the justification
#'   of the text boxes relative to `x` and `y`. These justification parameters
#'   are specified in the internal reference frame of the text boxes, so that,
#'   for example, `hjust` adjusts the vertical justification when the
#'   text is rotated 90 degrees to the left or right.
#' @param halign,valign Numerical values specifying the text justification
#'   inside the text boxes. If not specified, these default to `hjust` and
#'   `vjust`.
#' @param rot Angle of rotation for text, in degrees.
#' @param default.units Units of `x` and `y` if these are provided only as
#'   numerical values.
#' @param margin,padding Unit vectors of four elements each indicating the
#'   margin and padding around each text label in the order top, right,
#'   bottom, left. Margins are drawn outside the enclosing box (if any),
#'   and padding is drawn inside. To avoid rendering artifacts, it is best
#'   to specify these values in absolute units (such as points, mm, or inch)
#'   rather than in relative units (such as npc).
#' @param r The radius of the rounded corners. To avoid rendering artifacts,
#'   it is best to specify this in absolute units (such as points, mm, or inch)
#'   rather than in relative units (such as npc).
#' @param align_widths,align_heights Should the widths and heights of all
#'   the text boxes be aligned? Default is no.
#' @param name Name of the grob.
#' @param gp Other graphical parameters for drawing.
#' @param box_gp Graphical parameters for the enclosing box around each text label.
#' @param vp Viewport.
#' @param use_markdown Should the `text` input be treated as markdown? Default
#'   is yes.
#' @param debug Should debugging info be drawn? Default is no.
#' @return A grid [`grob`] that represents the formatted text.
#' @seealso [`textbox_grob()`]
#' @examples
#' library(grid)
#'
#' text <- c(
#'   "Some text **in bold.**", "Linebreaks<br>Linebreaks<br>Linebreaks",
#'   "*x*<sup>2</sup> + 5*x* + *C*<sub>*i*</sub>",
#'   "Some <span style='color:blue'>blue text **in bold.**</span><br>And *italics text.*<br>
#'    And some <span style='font-size:18pt; color:black'>large</span> text."
#' )
#'
#' x <- c(.2, .1, .7, .9)
#' y <- c(.8, .4, .1, .5)
#' rot <- c(0, 0, 45, -45)
#' gp = gpar(col = c("black", "red"), fontfamily = c("Palatino", "Courier", "Times", "Helvetica"))
#' box_gp = gpar(col = "black", fill = c("cornsilk", NA, "lightblue1", NA), lty = c(0, 1, 1, 1))
#' hjust <- c(0.5, 0, 0, 1)
#' vjust <- c(0.5, 1, 0, 0.5)
#'
#' g <- richtext_grob(
#'   text, x, y, hjust = hjust, vjust = vjust, rot = rot,
#'   padding = unit(c(6, 6, 4, 6), "pt"),
#'   r = unit(c(0, 2, 4, 8), "pt"),
#'   gp = gp, box_gp = box_gp
#' )
#' grid.newpage()
#' grid.draw(g)
#' grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))
#'
#' # multiple text labels with aligned boxes
#' text <- c("January", "February", "March", "April", "May")
#' x <- (1:5)/6 + 1/24
#' y <- rep(0.8, 5)
#' g <- richtext_grob(
#'   text, x, y, halign = 0, hjust = 1,
#'   rot = 45,
#'   padding = unit(c(3, 6, 1, 3), "pt"),
#'   r = unit(4, "pt"),
#'   align_widths = TRUE,
#'   box_gp = gpar(col = "black", fill = "cornsilk")
#' )
#' grid.newpage()
#' grid.draw(g)
#' grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))
#' @export
richtext_grob <- function(text, x = unit(0.5, "npc"), y = unit(0.5, "npc"),
                          hjust = 0.5, vjust = 0.5, halign = hjust, valign = vjust,
                          rot = 0, default.units = "npc",
                          margin = unit(c(0, 0, 0, 0), "pt"), padding = unit(c(0, 0, 0, 0), "pt"),
                          r = unit(0, "pt"), align_widths = FALSE, align_heights = FALSE,
                          name = NULL, gp = gpar(), box_gp = gpar(col = NA), vp = NULL,
                          use_markdown = TRUE, debug = FALSE) {
  # make sure x and y are units
  if (!is.unit(x))
    x <- unit(x, default.units)
  if (!is.unit(y))
    y <- unit(y, default.units)

  # make sure we can handle input text even if provided as factor
  text <- as.character(text)
  # convert NAs to empty strings
  text <- ifelse(is.na(text), "", text)

  # make sure margin and padding are of length 4
  margin <- rep(margin, length.out = 4)
  padding <- rep(padding, length.out = 4)

  # margin, padding, and r need to be in points
  margin_pt <- rep(0, 4)
  margin_pt[c(1, 3)] <- convertHeight(margin[c(1, 3)], "pt", valueOnly = TRUE)
  margin_pt[c(2, 4)] <- convertWidth(margin[c(2, 4)], "pt", valueOnly = TRUE)
  padding_pt <- rep(0, 4)
  padding_pt[c(1, 3)] <- convertHeight(padding[c(1, 3)], "pt", valueOnly = TRUE)
  padding_pt[c(2, 4)] <- convertWidth(padding[c(2, 4)], "pt", valueOnly = TRUE)
  r_pt <- convertUnit(r, "pt", valueOnly = TRUE)

  # make sure text, x, and y have the same length
  n <- unique(length(text), length(x), length(y))
  if (length(n) > 1) {
    stop("Arguments `text`, `x`, and `y` must have the same length.", call. = FALSE)
  }
  gp_list <- recycle_gpar(gp, n)
  box_gp_list <- recycle_gpar(box_gp, n)
  # need to convert x and y to lists so mapply can handle them properly
  x_list <- unit_to_list(x)
  y_list <- unit_to_list(y)

  inner_boxes <- mapply(
    make_inner_box,
    text,
    halign,
    valign,
    use_markdown,
    gp_list,
    SIMPLIFY = FALSE
  )

  # do we have to align the contents box sizes?
  if (isTRUE(align_widths) || isTRUE(align_heights)) {
    # yes, obtain max width and/or height as needed
    lapply(inner_boxes, bl_calc_layout)
    width <- vapply(inner_boxes, bl_box_width, numeric(1))
    height <-  vapply(inner_boxes, bl_box_height, numeric(1))
  }

  if (isTRUE(align_widths)) {
    width <- max(width)
  } else {
    width <- list(NULL)
  }
  if (isTRUE(align_heights)) {
    height <- max(height)
  } else {
    height <- list(NULL)
  }

  grobs <- mapply(
    make_outer_box,
    inner_boxes,
    width,
    height,
    x_list,
    y_list,
    halign,
    valign,
    hjust,
    vjust,
    rot,
    list(margin_pt),
    list(padding_pt),
    r_pt,
    box_gp_list,
    SIMPLIFY = FALSE
  )

  if (isTRUE(debug)) {
    ## calculate overall enclosing rectangle

    # first get xmax and xmin values for each child grob and overall
    xmax_pt <- vapply(grobs, function(x) {max(x$xext)}, numeric(1))
    xmin_pt <- vapply(grobs, function(x) {min(x$xext)}, numeric(1))
    xmax <- max(x + unit(xmax_pt, "pt"))
    xmin <- min(x + unit(xmin_pt, "pt"))

    # now similarly for ymax and ymin
    ymax_pt <- vapply(grobs, function(x) {max(x$yext)}, numeric(1))
    ymin_pt <- vapply(grobs, function(x) {min(x$yext)}, numeric(1))
    ymax <- max(y + unit(ymax_pt, "pt"))
    ymin <- min(y + unit(ymin_pt, "pt"))

    # now generate a polygon grob enclosing the entire area
    rect <- polygonGrob(
      x = unit.c(xmin, xmax, xmax, xmin),
      y = unit.c(ymin, ymin, ymax, ymax),
      gp = gpar(fill = "#E1F4FD", col = "#2523C1", lwd = 0.5)
    )

    grobs <- c(
      list(rect),
      grobs,
      list(
        pointsGrob(
          x, y, pch = 19, size = unit(5, "pt"),
          gp = gpar(col = "#2523C1"), default.units = default.units
        )
      )
    )
  }

  children <- do.call(gList, grobs)

  gTree(
    gp = gp,
    vp = vp,
    name = name,
    debug = debug,
    children = children,
    cl = "richtext_grob"
  )
}


make_inner_box <- function(text, halign, valign, use_markdown, gp) {
  if (use_markdown) {
    text <- markdown::markdownToHTML(text = text, options = c("use_xhtml", "fragment_only"))
  }
  doctree <- read_html(paste0("<!DOCTYPE html>", text))

  drawing_context <- setup_context(gp = gp, halign = halign, word_wrap = FALSE)
  boxlist <- process_tags(xml2::as_list(doctree)$html$body, drawing_context)
  vbox_inner <- bl_make_vbox(boxlist, vjust = 0, width_policy = "native")

  vbox_inner
}

make_outer_box <- function(vbox_inner, width, height, x, y, halign, valign,
                           hjust, vjust, rot,
                           margin_pt, padding_pt, r_pt, box_gp) {
  if (is.null(width)) {
    width <- 0
    width_policy <- "native"
  } else {
    width <- width + margin_pt[2] + margin_pt[4] + padding_pt[2] + padding_pt[4] # make space for margin and padding
    width_policy <- "fixed"
  }

  if (is.null(height)) {
    height <- 0
    height_policy <- "native"
  } else {
    height <- height + margin_pt[1] + margin_pt[3] + padding_pt[1] + padding_pt[3] # make space for margin and padding
    height_policy <- "fixed"
  }

  rect_box <- bl_make_rect_box(
    vbox_inner, width, height, margin_pt, padding_pt, box_gp,
    content_hjust = halign, content_vjust = valign,
    width_policy = width_policy, height_policy = height_policy, r = r_pt
  )
  vbox_outer <- bl_make_vbox(list(rect_box), hjust = hjust, vjust = vjust, width_policy = "native")

  bl_calc_layout(vbox_outer)
  grobs <- bl_render(vbox_outer)

  # calculate corner points
  # (We exclude x, y and keep everything in pt, to avoid unit calculations at this stage)
  # (lower left, lower right, upper left, upper right before rotation)
  theta <- rot*2*pi/360
  width <- bl_box_width(vbox_outer)
  height <- bl_box_height(vbox_outer)
  # lower left
  xll <- -hjust*cos(theta)*width + vjust*sin(theta)*height
  yll <- -hjust*sin(theta)*width - vjust*cos(theta)*height
  # lower right
  xlr <- xll + width*cos(theta)
  ylr <- yll + width*sin(theta)
  # upper left
  xul <- xll - height*sin(theta)
  yul <- yll + height*cos(theta)
  # upper right
  xur <- xul + width*cos(theta)
  yur <- yul + width*sin(theta)

  xext <- c(xll, xlr, xul, xur)
  yext <- c(yll, ylr, yul, yur)

  gTree(
    x = x,
    y = y,
    xext = xext,
    yext = yext,
    children = grobs,
    vp = viewport(x = x, y = y, just = c(0, 0), angle = rot)
  )
}



#' @export
heightDetails.richtext_grob <- function(x) {
  grobs <- x$children

  # in debug mode we have to trim off debug grobs
  if (isTRUE(x$debug)) {
    grobs <- grobs[c(-1, -length(grobs))]
  }

  if (length(grobs) == 1) {
    # shortcut for grobs with just one child; unit calcs not needed
    unit(max(grobs[[1]]$yext) - min(grobs[[1]]$yext), "pt")
  } else {
    # get ymax and ymin values for each child grob
    ymax <- lapply(grobs, function(x) {x$y + unit(max(x$yext), "pt")})
    ymin <- lapply(grobs, function(x) {x$y + unit(min(x$yext), "pt")})
    # now return the difference between the overal max and the overall min
    do.call(max, ymax) - do.call(min, ymin)
  }
}

#' @export
widthDetails.richtext_grob <- function(x) {
  grobs <- x$children

  # in debug mode we have to trim off debug grobs
  if (isTRUE(x$debug)) {
    grobs <- grobs[c(-1, -length(grobs))]
  }

  if (length(grobs) == 1) {
    # shortcut for grobs with just one child; unit calcs not needed
    unit(max(grobs[[1]]$xext) - min(grobs[[1]]$xext), "pt")
  } else {
    # get xmax and xmin values for each child grob
    xmax <- lapply(grobs, function(x) {x$x + unit(max(x$xext), "pt")})
    xmin <- lapply(grobs, function(x) {x$x + unit(min(x$xext), "pt")})
    # now return the difference between the overal max and the overall min
    do.call(max, xmax) - do.call(min, xmin)
  }
}

#' @export
ascentDetails.richtext_grob <- function(x) {
  heightDetails(x)
}

#' @export
descentDetails.richtext_grob <- function(x) {
  unit(0, "pt")
}

context("richtext-grob")

test_that("grobheight and grobwidth work", {
  # width is the same for textGrob and richtext_grob
  g <- textGrob("test")
  g2 <- richtext_grob("test")
  w <- convertWidth(grobWidth(g), "pt", valueOnly = TRUE)
  w2 <- convertWidth(grobWidth(g2), "pt", valueOnly = TRUE)
  expect_equal(w, w2)

  # height is slightly larger for richtext_grob, b/c descent is considered
  h <- convertHeight(grobHeight(g), "pt", valueOnly = TRUE)
  h2 <- convertHeight(grobHeight(g2), "pt", valueOnly = TRUE)
  expect_lt(h, h2)

  # width and height are flipped after rotating 90 degrees
  g <- textGrob("test", rot = 90)
  g2 <- richtext_grob("test", rot = 90)
  w <- convertWidth(grobWidth(g), "pt", valueOnly = TRUE)
  w2 <- convertWidth(grobWidth(g2), "pt", valueOnly = TRUE)
  expect_lt(w, w2)

  # height is slightly larger for richtext_grob, b/c descent is considered
  h <- convertHeight(grobHeight(g), "pt", valueOnly = TRUE)
  h2 <- convertHeight(grobHeight(g2), "pt", valueOnly = TRUE)
  expect_equal(h, h2)

  # position of multiple labels is taken into account
  g <- textGrob("test", x = unit(0, "pt"), y = unit(80, "pt"))
  g2 <- textGrob(c("test", "test"), x = unit(c(0, 50), "pt"), y = unit(c(80, 40), "pt"))
  w <- convertWidth(grobWidth(g), "pt", valueOnly = TRUE)
  w2 <- convertWidth(grobWidth(g2), "pt", valueOnly = TRUE)
  expect_equal(w + 50, w2)
  h <- convertHeight(grobHeight(g), "pt", valueOnly = TRUE)
  h2 <- convertHeight(grobHeight(g2), "pt", valueOnly = TRUE)
  expect_equal(h + 40, h2)

  # multiple labels, w rotation
  g <- textGrob("test", x = unit(0, "pt"), y = unit(80, "pt"), rot = 45)
  g2 <- textGrob(c("test", "test"), x = unit(c(0, 50), "pt"), y = unit(c(80, 40), "pt"), rot = 45)
  w <- convertWidth(grobWidth(g), "pt", valueOnly = TRUE)
  w2 <- convertWidth(grobWidth(g2), "pt", valueOnly = TRUE)
  expect_equal(w + 50, w2)
  h <- convertHeight(grobHeight(g), "pt", valueOnly = TRUE)
  h2 <- convertHeight(grobHeight(g2), "pt", valueOnly = TRUE)
  expect_equal(h + 40, h2)

  # grob height and width are identical with and without debug info
  text <- c(
    "Some text **in bold.**<br>(centered)", "Linebreaks<br>Linebreaks<br>Linebreaks",
    "*x*<sup>2</sup> + 5*x* + *C*<sub>i</sub><br>*a* = 5"
  )
  x <- c(.4, .3, .8)
  y <- c(.8, .5, .3)
  rot <- c(0, -45, 45)
  halign <- c(0.5, 0, 1)
  valign <- c(0.5, 1, 0)

  g1 <- richtext_grob(
    text, x, y, halign = halign, valign = valign, rot = rot,
    padding = unit(c(6, 6, 4, 6), "pt"),
    r = unit(c(0, 4, 8), "pt"),
    debug = FALSE
  )

  g2 <- richtext_grob(
    text, x, y, halign = halign, valign = valign, rot = rot,
    padding = unit(c(6, 6, 4, 6), "pt"),
    r = unit(c(0, 4, 8), "pt"),
    debug = TRUE
  )

  w1 <- convertWidth(grobWidth(g1), "pt", valueOnly = TRUE)
  w2 <- convertWidth(grobWidth(g2), "pt", valueOnly = TRUE)
  expect_equal(w1, w2)

  h1 <- convertHeight(grobHeight(g1), "pt", valueOnly = TRUE)
  h2 <- convertHeight(grobHeight(g2), "pt", valueOnly = TRUE)
  expect_equal(h1, h2)
})

test_that("misc. tests", {
  # empty strings work
  expect_silent(richtext_grob(""))
  expect_silent(richtext_grob(" "))

  # NAs work
  expect_silent(richtext_grob(c(" ", "abc", NA)))
})

test_that("visual tests", {
  draw_labels <- function() {
    function() {
      text <- c(
        "**Various text boxes in different stylings**",
        "Some text **in bold.**<br>(centered)", "Linebreaks<br>Linebreaks<br>Linebreaks",
        "*x*<sup>2</sup> + 5*x* + *C*<sub>i</sub><br>*a* = 5"
      )

      x <- c(0, .4, .3, .8)
      y <- c(1, .8, .5, .3)
      rot <- c(0, 0, -45, 45)
      gp = gpar(col = c("black", "red"))
      box_gp = gpar(col = "black", fill = c(NA, "cornsilk", NA, "lightblue1"), lty = c(0, 1, 1, 1))
      hjust <- c(0, 0.5, 0, 1)
      vjust <- c(1, 0.5, 1, 0)

      g <- richtext_grob(
        text, x, y, hjust = hjust, vjust = vjust, rot = rot,
        padding = unit(c(6, 6, 4, 6), "pt"),
        r = unit(c(0, 0, 4, 8), "pt"),
        gp = gp, box_gp = box_gp
      )
      grid.draw(g)
      grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))
      invisible()
    }
  }

  expect_doppelganger("Various text boxes", draw_labels())

  draw_labels_debug <- function() {
    function() {
      text <- c(
        "Some text **in bold.**<br>(centered)", "Linebreaks<br>Linebreaks<br>Linebreaks",
        "*x*<sup>2</sup> + 5*x* + *C*<sub>i</sub><br>*a* = 5"
      )

      x <- c(.4, .3, .8)
      y <- c(.8, .5, .3)
      rot <- c(0, -45, 45)
      gp = gpar(col = c("black", "red", "black"))
      box_gp = gpar(col = "black", fill = c("cornsilk", NA, "lightblue1"), lty = c(1, 1, 1))
      hjust <- c(0.5, 0, 1)
      vjust <- c(0.5, 1, 0)

      g <- richtext_grob(
        text, x, y, hjust = hjust, vjust = vjust, rot = rot,
        padding = unit(c(6, 6, 4, 6), "pt"),
        r = unit(c(0, 4, 8), "pt"),
        gp = gp, box_gp = box_gp,
        debug = TRUE
      )
      grid.draw(g)
      grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))
      invisible()
    }
  }

  expect_doppelganger("Various text boxes w/ debug", draw_labels_debug())

  draw_aligned_heights <- function() {
    function() {
      text <- c(
        "Some text **in bold.**<br>(centered)", "Linebreaks<br>Linebreaks<br>Linebreaks",
        "*x*<sup>2</sup> + 5*x* + *C*<sub>i</sub><br>*a* = 5"
      )

      x <- c(.4, .3, .8)
      y <- c(.8, .5, .3)
      rot <- c(0, -45, 45)
      gp = gpar()
      box_gp = gpar(col = "black", fill = c("cornsilk", NA, "lightblue1"))
      hjust <- c(0.5, 0, 1)
      vjust <- c(0.5, 1, 0)

      g <- richtext_grob(
        text, x, y, halign = 0.5, valign = 0.5,
        hjust = hjust, vjust = vjust, rot = rot,
        align_heights = TRUE,
        padding = unit(c(6, 6, 4, 6), "pt"),
        r = unit(c(0, 4, 8), "pt"),
        gp = gp, box_gp = box_gp
      )
      grid.draw(g)
      grid.text("Box heights aligned, content centered", gp = gpar(fontface = "bold"), 0.02, 1, hjust = 0, vjust = 1.2)
      grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))
      invisible()
    }
  }

  expect_doppelganger("Aligned heights", draw_aligned_heights())

  draw_aligned_widths <- function() {
    function() {
      text <- c(
        "Some text **in bold.**<br>(centered)", "Linebreaks<br>Linebreaks<br>Linebreaks",
        "*x*<sup>2</sup> + 5*x* + *C*<sub>i</sub><br>*a* = 5"
      )

      x <- c(.4, .3, .8)
      y <- c(.8, .5, .3)
      rot <- c(0, -45, 45)
      gp = gpar()
      box_gp = gpar(col = "black", fill = c("cornsilk", NA, "lightblue1"))
      hjust <- c(0.5, 0, 1)
      vjust <- c(0.5, 1, 0)

      g <- richtext_grob(
        text, x, y, halign = 0.5, valign = 0.5,
        hjust = hjust, vjust = vjust, rot = rot,
        align_widths = TRUE,
        padding = unit(c(6, 6, 4, 6), "pt"),
        r = unit(c(0, 4, 8), "pt"),
        gp = gp, box_gp = box_gp
      )
      grid.draw(g)
      grid.text("Box widths aligned, content centered", gp = gpar(fontface = "bold"), 0.02, 1, hjust = 0, vjust = 1.2)
      grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))
      invisible()
    }
  }

  expect_doppelganger("Aligned widths", draw_aligned_widths())

})

#' Improved text rendering support for grid graphics
#'
#' The gridtext package provides two new grobs, [`richtext_grob()`] and
#' [`textbox_grob()`], which support drawing of formatted text labels and
#' formatted text boxes, respectively.
#' @name gridtext
#' @docType package
#' @useDynLib gridtext, .registration = TRUE
#' @importFrom Rcpp sourceCpp
#' @import grid
#' @import rlang
#' @importFrom xml2 read_html
NULL

# create drawing context with defined state
# halign defines horizontal text alignment (0 = left aligned, 0.5 = centered, 1 = right aligned)
setup_context <- function(fontsize = 12, fontfamily = "", fontface = "plain", color = "black",
                          lineheight = 1.2, halign = 0, word_wrap = TRUE, gp = NULL) {
  if (is.null(gp)) {
    gp <- gpar(
      fontsize = fontsize, fontfamily = fontfamily, fontface = fontface,
      col = color, cex = 1, lineheight = lineheight
    )
  }
  gp <- update_gpar(get.gpar(), gp)

  set_context_gp(list(yoff_pt = 0, halign = halign, word_wrap = word_wrap), gp)
}

# update a given drawing context with the values provided via ...
update_context <- function(drawing_context, ...) {
  dc_new <- list(...)
  names_new <- names(dc_new)
  names_old <- names(drawing_context)
  drawing_context[intersect(names_old, names_new)] <- NULL
  c(drawing_context, dc_new)
}

set_style <- function(drawing_context, style = NULL) {
  if (is.null(style)) return(drawing_context)

  css <- parse_css(style)

  if (!is.null(css$`font-size`)) {
    font_size = convert_css_unit_pt(css$`font-size`)
  } else {
    font_size = NULL
  }

  drawing_context <- set_context_gp(
    drawing_context,
    gpar(col = css$color, fontfamily = css$`font-family`, fontsize = font_size)
  )
}


# helper functions --------------------------------------------------------

# update a gpar object with new values
update_gpar <- function(gp, gp_new) {
  names_new <- names(gp_new)
  names_old <- names(gp)
  gp[c(intersect(names_old, names_new), "fontface")] <- NULL
  gp_new["fontface"] <- NULL
  do.call(gpar, c(gp, gp_new))
}

# update the gpar object of a drawing context
set_context_gp <- function(drawing_context, gp = NULL) {
  gp <- update_gpar(drawing_context$gp, gp)
  font_info <- text_details("", gp)
  linespacing_pt <- gp$lineheight * gp$fontsize
  em_pt <- gp$fontsize

  update_context(
    drawing_context,
    gp = gp,
    ascent_pt = font_info$ascent_pt,
    descent_pt = font_info$descent_pt,
    linespacing_pt = linespacing_pt,
    em_pt = em_pt
  )
}

# update the fontface of a drawing context
set_context_fontface <- function(drawing_context, fontface = "plain", overwrite = FALSE) {
  font_old <- drawing_context$gp$font

  # combine bold and italic if needed
  if (!isTRUE(overwrite)) {
    if (isTRUE(fontface == "italic") && isTRUE(font_old == 2)) { # see ?grid::gpar for fontface codes
      fontface <- "bold.italic"
    } else if (isTRUE(fontface == "bold") && isTRUE(font_old == 3)) {
      fontface <- "bold.italic"
    }
  }

  set_context_gp(drawing_context, gpar(fontface = fontface))
}

#' Draw formatted multi-line text with word wrap
#'
#' The function `textbox_grob()` is intended to render multi-line text
#' labels that require automatic word wrapping. It is similar to
#' [`richtext_grob()`], but there are a few important differences. First,
#' while [`richtext_grob()`] is vectorized, `textbox_grob()` is not. It
#' can draw only a single text box at a time. Second, `textbox_grob()`
#' doesn't support rendering the text box at arbitrary angles. Only
#' four different orientations are supported, corresponding to a
#' rotation by 0, 90, 180, and 270 degrees.
#'
#' @param text Character vector containing Markdown/HTML string to draw.
#' @param x,y Unit objects specifying the location of the reference point.
#'   If set to `NULL` (the default), these values are chosen based on the
#'   values of `hjust` and `vjust` such that the box is appropriately
#'   justified in the enclosing viewport.
#' @param width,height Unit objects specifying width and height of the
#'   grob. A value of `NULL` means take up exactly the space necessary
#'   to render all content. Use a value of `unit(1, "npc")` to have the
#'   box take up all available space.
#' @param minwidth,minheight,maxwidth,maxheight Min and max values for
#'   width and height. Set to `NULL` to impose neither a minimum nor
#'   a maximum. Note: `minheight` and `maxheight` do not work if `width = NULL`.
#' @param hjust,vjust Numerical values specifying the justification
#'   of the text box relative to the reference point defined by `x` and `y`. These
#'   justification parameters are specified in the internal reference frame of
#'   the text box, so that, for example, `hjust` adjusts the vertical
#'   justification when the text box is left- or right-rotated.
#' @param halign,valign Numerical values specifying the justification of the text
#'   inside the text box.
#' @param default.units Units of `x`, `y`, `width`, `height`, `minwidth`,
#'   `minheight`, `maxwidth`, `maxheight` if these are provided only as
#'   numerical values.
#' @param margin,padding Unit vectors of four elements each indicating the
#'   margin and padding around each text label in the order top, right,
#'   bottom, left. Margins are drawn outside the enclosing box (if any),
#'   and padding is drawn inside. To avoid rendering artifacts, it is best
#'   to specify these values in absolute units (such as points, mm, or inch)
#'   rather than in relative units (such as npc).
#' @param r The radius of the rounded corners. To avoid rendering artifacts,
#'   it is best to specify this in absolute units (such as points, mm, or inch)
#'   rather than in relative units (such as npc).
#' @param orientation Orientation of the box. Allowed values are `"upright"`,
#'   `"left-rotated"`, `"right-rotated"`, and `"inverted"`, corresponding to
#'   a rotation by 0, 90, 270, and 180 degrees counter-clockwise, respectively.
#' @param name Name of the grob.
#' @param gp Other graphical parameters for drawing.
#' @param box_gp Graphical parameters for the enclosing box around each text label.
#' @param vp Viewport.
#' @param use_markdown Should the `text` input be treated as markdown?
#' @return A grid [`grob`] that represents the formatted text.
#' @seealso [`richtext_grob()`]
#' @examples
#' library(grid)
#' g <- textbox_grob(
#'   "**The quick brown fox jumps over the lazy dog.**<br><br>
#'   The quick brown fox jumps over the lazy dog.
#'   The **quick <span style='color:brown;'>brown fox</span>** jumps over the lazy dog.
#'   The quick brown fox jumps over the lazy dog.",
#'   x = unit(0.5, "npc"), y = unit(0.7, "npc"), halign = 0, valign = 1,
#'   gp = gpar(fontsize = 15),
#'   box_gp = gpar(col = "black", fill = "lightcyan1"),
#'   r = unit(5, "pt"),
#'   padding = unit(c(10, 10, 10, 10), "pt"),
#'   margin = unit(c(0, 10, 0, 10), "pt")
#' )
#' grid.newpage()
#' grid.draw(g)
#'
#' # internal vs. external alignment
#' g1 <- textbox_grob(
#'   "The quick brown fox jumps over the lazy dog.",
#'   hjust = 0, vjust = 1, halign = 0, valign = 1,
#'   width = unit(1.5, "inch"), height = unit(1.5, "inch"),
#'   box_gp = gpar(col = "black", fill = "cornsilk"),
#'   padding = unit(c(2, 2, 2, 2), "pt"),
#'   margin = unit(c(5, 5, 5, 5), "pt")
#' )
#' g2 <- textbox_grob(
#'   "The quick brown fox jumps over the lazy dog.",
#'   hjust = 1, vjust = 1, halign = 0.5, valign = 0.5,
#'   width = unit(1.5, "inch"), height = unit(1.5, "inch"),
#'   box_gp = gpar(col = "black", fill = "cornsilk"),
#'   padding = unit(c(2, 2, 2, 2), "pt"),
#'   margin = unit(c(5, 5, 5, 5), "pt")
#' )
#' g3 <- textbox_grob(
#'   "The quick brown fox jumps over the lazy dog.",
#'   hjust = 0, vjust = 0, halign = 1, valign = 1,
#'   width = unit(1.5, "inch"), height = unit(1.5, "inch"),
#'   box_gp = gpar(col = "black", fill = "cornsilk"),
#'   padding = unit(c(2, 2, 2, 2), "pt"),
#'   margin = unit(c(5, 5, 5, 5), "pt")
#' )
#' g4 <- textbox_grob(
#'   "The quick brown fox jumps over the lazy dog.",
#'   hjust = 1, vjust = 0, halign = 0, valign = 0,
#'   width = unit(1.5, "inch"), height = unit(1.5, "inch"),
#'   box_gp = gpar(col = "black", fill = "cornsilk"),
#'   padding = unit(c(2, 2, 2, 2), "pt"),
#'   margin = unit(c(5, 5, 5, 5), "pt")
#' )
#' grid.newpage()
#' grid.draw(g1)
#' grid.draw(g2)
#' grid.draw(g3)
#' grid.draw(g4)
#'
#' # internal vs. external alignment, with rotated boxes
#' g1 <- textbox_grob(
#'   "The quick brown fox jumps over the lazy dog.",
#'   hjust = 1, vjust = 1, halign = 0, valign = 1,
#'   width = unit(1.5, "inch"), height = unit(1.5, "inch"),
#'   orientation = "left-rotated",
#'   box_gp = gpar(col = "black", fill = "cornsilk"),
#'   padding = unit(c(2, 2, 2, 2), "pt"),
#'   margin = unit(c(5, 5, 5, 5), "pt")
#' )
#' g2 <- textbox_grob(
#'   "The quick brown fox jumps over the lazy dog.",
#'   hjust = 0, vjust = 1, halign = 0.5, valign = 0.5,
#'   width = unit(1.5, "inch"), height = unit(1.5, "inch"),
#'   orientation = "right-rotated",
#'   box_gp = gpar(col = "black", fill = "cornsilk"),
#'   padding = unit(c(2, 2, 2, 2), "pt"),
#'   margin = unit(c(5, 5, 5, 5), "pt")
#' )
#' g3 <- textbox_grob(
#'   "The quick brown fox jumps over the lazy dog.",
#'   hjust = 1, vjust = 1, halign = 1, valign = 1,
#'   width = unit(1.5, "inch"), height = unit(1.5, "inch"),
#'   orientation = "inverted",
#'   box_gp = gpar(col = "black", fill = "cornsilk"),
#'   padding = unit(c(2, 2, 2, 2), "pt"),
#'   margin = unit(c(5, 5, 5, 5), "pt")
#' )
#' g4 <- textbox_grob(
#'   "The quick brown fox jumps over the lazy dog.",
#'   hjust = 1, vjust = 0, halign = 0, valign = 0,
#'   width = unit(1.5, "inch"), height = unit(1.5, "inch"),
#'   orientation = "upright",
#'   box_gp = gpar(col = "black", fill = "cornsilk"),
#'   padding = unit(c(2, 2, 2, 2), "pt"),
#'   margin = unit(c(5, 5, 5, 5), "pt")
#' )
#' grid.newpage()
#' grid.draw(g1)
#' grid.draw(g2)
#' grid.draw(g3)
#' grid.draw(g4)
#' @export
textbox_grob <- function(text, x = NULL, y = NULL,
                         width = unit(1, "npc"), height = NULL,
                         minwidth = NULL, maxwidth = NULL,
                         minheight = NULL, maxheight = NULL,
                         hjust = 0.5, vjust = 0.5, halign = 0, valign = 1,
                         default.units = "npc",
                         margin = unit(c(0, 0, 0, 0), "pt"), padding = unit(c(0, 0, 0, 0), "pt"),
                         r = unit(0, "pt"),
                         orientation = c("upright", "left-rotated", "right-rotated", "inverted"),
                         name = NULL, gp = gpar(), box_gp = gpar(col = NA), vp = NULL,
                         use_markdown = TRUE) {
  # make sure x, y, width, height are units
  x <- with_unit(x, default.units)
  y <- with_unit(y, default.units)
  width <- with_unit(width, default.units)
  height <- with_unit(height, default.units)
  minwidth <- with_unit(minwidth, default.units)
  minheight <- with_unit(minheight, default.units)
  maxwidth <- with_unit(maxwidth, default.units)
  maxheight <- with_unit(maxheight, default.units)

  # make sure we can handle input text even if provided as factor
  text <- as.character(text)
  # convert NAs to empty strings
  text <- ifelse(is.na(text), "", text)

  # determine orientation and adjust accordingly
  orientation <- match.arg(orientation)
  angle <- 0 # default value
  if (orientation == "upright") {
    if (is.null(x)) {
      x <- unit(hjust, "npc")
    }
    if (is.null(y)) {
      y <- unit(vjust, "npc")
    }
    flip <- FALSE
  } else if (orientation == "left-rotated") {
    angle <- 90
    if (is.null(x)) {
      x <- unit(1-vjust, "npc")
    }
    if (is.null(y)) {
      y <- unit(hjust, "npc")
    }
    flip <- TRUE
  } else if (orientation == "right-rotated") {
    angle <- -90
    if (is.null(x)) {
      x <- unit(vjust, "npc")
    }
    if (is.null(y)) {
      y <- unit(1-hjust, "npc")
    }
    flip <- TRUE
  } else if (orientation == "inverted") {
    angle <- 180
    if (is.null(x)) {
      x <- unit(1-hjust, "npc")
    }
    if (is.null(y)) {
      y <- unit(1-vjust, "npc")
    }
    flip <- FALSE
  }

  # make sure margin and padding are of length 4
  margin <- rep(margin, length.out = 4)
  padding <- rep(padding, length.out = 4)

  # margin, padding, and r need to be in points
  margin_pt <- rep(0, 4)
  margin_pt[c(1, 3)] <- convertHeight(margin[c(1, 3)], "pt", valueOnly = TRUE)
  margin_pt[c(2, 4)] <- convertWidth(margin[c(2, 4)], "pt", valueOnly = TRUE)
  padding_pt <- rep(0, 4)
  padding_pt[c(1, 3)] <- convertHeight(padding[c(1, 3)], "pt", valueOnly = TRUE)
  padding_pt[c(2, 4)] <- convertWidth(padding[c(2, 4)], "pt", valueOnly = TRUE)
  r_pt <- convertUnit(r, "pt", valueOnly = TRUE)

  # make sure text, x, y, and width have at most length 1
  n <- max(length(text), length(x), length(y), length(width), length(height))
  if (n > 1) {
    stop("The function textbox_grob() is not vectorized.", call. = FALSE)
  }

  # now parse html
  if (use_markdown) {
    text <- markdown::markdownToHTML(text = text, options = c("use_xhtml", "fragment_only"))
  }
  doctree <- read_html(paste0("<!DOCTYPE html>", text))

  # if width is set to NULL, we use the native size policy and turn off word wrap
  if (is.null(width)) {
    width_policy <- "native"
    word_wrap <- FALSE
  } else {
    width_policy <- "relative"
    word_wrap <- TRUE
  }

  drawing_context <- setup_context(gp = gp, halign = halign, word_wrap = word_wrap)
  boxlist <- process_tags(xml2::as_list(doctree)$html$body, drawing_context)
  vbox_inner <- bl_make_vbox(boxlist, vjust = 0, width_pt = 100, width_policy = width_policy)

  gTree(
    width = width,
    height = height,
    x = x,
    y = y,
    halign = halign,
    valign = valign,
    hjust = hjust,
    vjust = vjust,
    minwidth = minwidth,
    minheight = minheight,
    maxwidth = maxwidth,
    maxheight = maxheight,
    angle = angle,
    flip = flip,
    vbox_inner = vbox_inner,
    margin_pt = margin_pt,
    padding_pt = padding_pt,
    r_pt = r_pt,
    gp = gp,
    box_gp = box_gp,
    vp = vp,
    name = name,
    cl = "textbox_grob"
  )
}

#' @export
makeContext.textbox_grob <- function(x) {
  if (is.null(x$width)) {
    width_policy <- "native"
  } else {
    width_policy <- "fixed"
  }

  width_pt <- current_width_pt(x, x$width, x$flip)
  minwidth_pt <- current_width_pt(x, x$minwidth, x$flip, convert_null = FALSE)
  maxwidth_pt <- current_width_pt(x, x$maxwidth, x$flip, convert_null = FALSE)

  if (!is.null(minwidth_pt) && width_pt < minwidth_pt) {
    width_pt <- minwidth_pt
  }
  if (!is.null(maxwidth_pt) && width_pt > maxwidth_pt) {
    width_pt <- maxwidth_pt
  }

  height_pt <- current_height_pt(x, x$height, x$flip, convert_null = FALSE)
  minheight_pt <- current_height_pt(x, x$minheight, x$flip, convert_null = FALSE)
  maxheight_pt <- current_height_pt(x, x$maxheight, x$flip, convert_null = FALSE)

  if (is.null(height_pt)) {
    height_pt <- 0
    height_policy <- "native"
  } else {
    height_policy <- "fixed"
  }

  rect_box <- bl_make_rect_box(
    x$vbox_inner, width_pt, height_pt, x$margin_pt, x$padding_pt, x$box_gp,
    content_hjust = x$halign, content_vjust = x$valign,
    width_policy = width_policy, height_policy = height_policy, r = x$r_pt
  )
  vbox_outer <- bl_make_vbox(
    list(rect_box), width_pt = width_pt,
    hjust = x$hjust, vjust = x$vjust, width_policy = width_policy
  )
  bl_calc_layout(vbox_outer, width_pt)
  width_pt <- bl_box_width(vbox_outer)
  height_pt <- bl_box_height(vbox_outer)

  # check if height needs to be adjusted, and relayout if necessary
  relayout <- FALSE
  if (!is.null(minheight_pt) && height_pt < minheight_pt) {
    height_pt <- minheight_pt
    relayout <- TRUE
  }
  if (!is.null(maxheight_pt) && height_pt > maxheight_pt) {
    height_pt <- maxheight_pt
    relayout <- TRUE
  }
  if (relayout) {
    rect_box <- bl_make_rect_box(
      x$vbox_inner, width_pt, height_pt, x$margin_pt, x$padding_pt, x$box_gp,
      content_hjust = x$halign, content_vjust = x$valign,
      width_policy = width_policy, height_policy = "fixed", r = x$r_pt
    )
    vbox_outer <- bl_make_vbox(list(rect_box), width_pt = width_pt, hjust = x$hjust, vjust = x$vjust, width_policy = width_policy)
    bl_calc_layout(vbox_outer, width_pt)
    width_pt <- bl_box_width(vbox_outer)
    height_pt <- bl_box_height(vbox_outer)
  }

  x$vbox_outer <- vbox_outer

  if (isTRUE(x$flip)) {
    x$width_pt <- height_pt
    x$height_pt <- width_pt
  } else {
    x$width_pt <- width_pt
    x$height_pt <- height_pt
  }

  vp <- viewport(x$x, x$y, just = c(x$hjust, x$vjust), angle = x$angle)
  if (is.null(x$vp)) {
    x$vp <- vp
  } else {
    x$vp <- vpStack(x$vp, vp)
  }
  x
}

#' @export
makeContent.textbox_grob <- function(x) {
  # get absolute coordinates of the grob
  x_pt <- convertX(unit(x$hjust, "npc"), "pt", valueOnly = TRUE)
  y_pt <- convertY(unit(x$vjust, "npc"), "pt", valueOnly = TRUE)

  grobs <- bl_render(x$vbox_outer, x_pt, y_pt)

  setChildren(x, grobs)
}


#' @export
heightDetails.textbox_grob <- function(x) {
  unit(x$height_pt, "pt")
}

#' @export
widthDetails.textbox_grob <- function(x) {
  unit(x$width_pt, "pt")
}

#' @export
ascentDetails.textbox_grob <- function(x) {
  unit(x$height_pt, "pt")
}

#' @export
descentDetails.textbox_grob <- function(x) {
  unit(0, "pt")
}

context("textbox-grob")

test_that("misc. tests", {
  # empty strings work
  expect_silent(textbox_grob(""))
  expect_silent(textbox_grob(" "))

  # NAs work
  expect_silent(textbox_grob(NA))
})

test_that("visual tests", {
  draw_box <- function() {
    function() {
      g <- textbox_grob(
        "**The quick brown fox jumps over the lazy dog.**<br><br>
  The quick brown fox jumps over the lazy dog.
  The **quick <span style='color:brown;'>brown fox</span>** jumps over the lazy dog.
  The quick brown fox jumps over the lazy dog.",
        y = unit(0.9, "npc"), vjust = 1,
        gp = gpar(fontsize = 15),
        box_gp = gpar(col = "black", fill = "lightcyan1"),
        r = unit(5, "pt"),
        padding = unit(c(10, 10, 10, 10), "pt"),
        margin = unit(c(0, 10, 0, 10), "pt")
      )
      grid.draw(g)
      grid.text("  Box spanning entire viewport, with margins", 0, 1, hjust = 0, vjust = 1.2)
      grid.points(0.5, 0.9, default.units = "npc", pch = 19, size = unit(5, "pt"))
      invisible()
    }
  }

  expect_doppelganger("Box spanning entire viewport, with margins", draw_box())

  draw_align_upright <- function() {
    function() {
      g1 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 1, valign = 1, halign = 0,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g2 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 1, vjust = 1, valign = 0.5, halign = 0.5,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g3 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 0, valign = 1, halign = 1,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g4 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 1, vjust = 0, valign = 0, halign = 0,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      grid.draw(g1)
      grid.draw(g2)
      grid.draw(g3)
      grid.draw(g4)
      invisible()
    }
  }

  expect_doppelganger("Multiple boxes, internal alignment", draw_align_upright())


  draw_align_left_rotated <- function() {
    function() {
      g1 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 1, valign = 1, halign = 0,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "left-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g2 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 1, vjust = 1, valign = 0.5, halign = 0.5,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "left-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g3 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 0, valign = 1, halign = 1,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "left-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g4 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 1, vjust = 0, valign = 0, halign = 0,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "left-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      grid.draw(g1)
      grid.draw(g2)
      grid.draw(g3)
      grid.draw(g4)
      invisible()
    }
  }

  expect_doppelganger("Multiple boxes left rotated, internal alignment", draw_align_left_rotated())


  draw_align_right_rotated <- function() {
    function() {
      g1 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 1, valign = 1, halign = 0,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "right-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g2 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 1, vjust = 1, valign = 0.5, halign = 0.5,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "right-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g3 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 0, valign = 1, halign = 1,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "right-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g4 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 1, vjust = 0, valign = 0, halign = 0,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "right-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      grid.draw(g1)
      grid.draw(g2)
      grid.draw(g3)
      grid.draw(g4)
      invisible()
    }
  }

  expect_doppelganger("Multiple boxes right rotated, internal alignment", draw_align_right_rotated())


  draw_align_inverted <- function() {
    function() {
      g1 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 1, valign = 1, halign = 0,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "inverted",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g2 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 1, vjust = 1, valign = 0.5, halign = 0.5,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "inverted",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g3 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 0, valign = 1, halign = 1,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "inverted",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      g4 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 1, vjust = 0, valign = 0, halign = 0,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "inverted",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 5, 5, 5), "pt")
      )
      grid.draw(g1)
      grid.draw(g2)
      grid.draw(g3)
      grid.draw(g4)
      invisible()
    }
  }
  expect_doppelganger("Multiple boxes inverted, internal alignment", draw_align_inverted())

  draw_rotated_fixedpoint <- function() {
    function() {
      g1 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 1,
        x = 0.4, y = 0.6,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "upright",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 0, 5, 0), "pt")
      )
      g2 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 1,
        x = 0.4, y = 0.6,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "left-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 0, 5, 0), "pt")
      )
      g3 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 1,
        x = 0.4, y = 0.6,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "right-rotated",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 0, 5, 0), "pt")
      )
      g4 <- textbox_grob(
        "The quick brown fox jumps over the lazy dog.",
        hjust = 0, vjust = 1,
        x = 0.4, y = 0.6,
        width = unit(1.5, "inch"), height = unit(1.5, "inch"),
        orientation = "inverted",
        box_gp = gpar(col = "black", fill = "cornsilk"),
        padding = unit(c(2, 2, 2, 2), "pt"),
        margin = unit(c(5, 0, 5, 0), "pt")
      )
      grid.draw(g1)
      grid.draw(g2)
      grid.draw(g3)
      grid.draw(g4)
      grid.points(0.4, 0.6, default.units = "npc", pch = 19, size = unit(5, "pt"))
      invisible()
    }
  }
  expect_doppelganger("Rotation around fixed point", draw_rotated_fixedpoint())

})

# takes a graphical parameters object gp and returns a list of
# length n of appropriately recycled elements from gp
recycle_gpar <- function(gp = NULL, n = 1) {
  make_gpar <- function(n, ...) {
    structure(
      list(...),
      class = "gpar"
    )
  }

  args <- c(list(make_gpar, n = 1:n), gp, list(SIMPLIFY = FALSE))
  do.call(mapply, args)
}

# converts a unit vector into a list of individual unit objects
unit_to_list <- function(u)
{
  lapply(seq_along(u), function(i) u[i])
}

# An empty grob of no extent
#
# An empty grob of no extent. Useful when a grob is needed but no
# content is desired.
# @keywords internal
# @export
zeroGrob <- function() .zeroGrob

.zeroGrob <- grid::grob(cl = "zeroGrob", name = "NULL")

widthDetails.zeroGrob <- function(x) unit(0, "cm")
heightDetails.zeroGrob <- function(x) unit(0, "cm")
grobWidth.zeroGrob <- function(x) unit(0, "cm")
grobHeight.zeroGrob <- function(x) unit(0, "cm")
drawDetails.zeroGrob <- function(x, recording) {}

read_image <- function(path) {
  if (isTRUE(grepl("\\.png$", path, ignore.case = TRUE))) {
    img <- png::readPNG(get_file(path), native = TRUE)
  } else if (isTRUE(grepl("(\\.jpg$)|(\\.jpeg)", path, ignore.case = TRUE))) {
    img <- jpeg::readJPEG(get_file(path), native = TRUE)
  } else {
    warning(paste0("Image type not supported: ", path), call. = FALSE)
    img <- grDevices::as.raster(matrix(0, 10, 10))
  }
}

get_file <- function(path) {
  if (is_url(path)) {
    curl::curl_fetch_memory(path)$content
  } else {
    path
  }
}

is_url <- function(path)
{
  grepl("https?://", path)
}

test_that("get_file works", {
  # skip test on cran because the url could be broken in the future
  skip_on_cran()
  # get_file returns raw data if it's an url and a character path if it's
  # a local path. That's why we test it with the function read_image that calls it
  expect_identical(
    read_image("https://upload.wikimedia.org/wikipedia/commons/6/62/Biedronka.drs.png"),
    read_image("../figs/test_image.png")
  )
})

process_text <- function(node, drawing_context) {
  tokens <- stringr::str_split(stringr::str_squish(node), "[[:space:]]+")[[1]]

  # make interior boxes
  boxes <- lapply(tokens,
    function(token) {
      list(
        bl_make_text_box(token, drawing_context$gp, drawing_context$yoff_pt),
        bl_make_regular_space_glue(drawing_context$gp)
      )
    }
  )

  # if node starts with space, add glue at beginning
  if (isTRUE(grepl("^[[:space:]]", node))) {
    boxes <- c(list(bl_make_regular_space_glue(drawing_context$gp)), boxes)
  }

  boxes <- unlist(boxes, recursive = FALSE)

  # if node doesn't end with space, remove glue at end
  if (!isTRUE(grepl("[[:space:]]$", node))) {
    boxes[[length(boxes)]] <- NULL
  }
  boxes
}

process_tag_b <- function(node, drawing_context) {
  attr <- attributes(node)
  drawing_context <- set_style(drawing_context, attr$style)

  process_tags(node, set_context_fontface(drawing_context, "bold"))
}

process_tag_br <- function(node, drawing_context) {
  list(
    bl_make_text_box("", drawing_context$gp),
    bl_make_forced_break_penalty()
  )
}

process_tag_i <- function(node, drawing_context) {
  attr <- attributes(node)
  drawing_context <- set_style(drawing_context, attr$style)

  process_tags(node, set_context_fontface(drawing_context, "italic"))
}

process_tag_img <- function(node, drawing_context) {
  attr <- attributes(node)

  height <- attr$height
  if (is.null(height)) {
    height <- 0
    height_policy <- "native"
  } else {
    height <- as.numeric(height)
    height_policy <- "fixed"
  }

  width <- attr$width
  if (is.null(width)) {
    width <- 0
    width_policy <- "native"
  } else {
    width <- as.numeric(width)
    width_policy <- "fixed"
  }

  if (height_policy == "fixed" && width_policy == "fixed") {
    respect_asp <- FALSE
  } else {
    respect_asp <- TRUE
  }

  # read image
  img <- read_image(attr$src)

  # dpi = 72.27 turns lengths in pixels to lengths in pt
  rb <- bl_make_raster_box(
    img, width, height, width_policy, height_policy,
    respect_aspect = respect_asp, dpi = 72.27
  )

  list(rb)
}

process_tag_p <- function(node, drawing_context) {
  attr <- attributes(node)
  drawing_context <- set_style(drawing_context, attr$style)

  boxes <- unlist(
    list(
      process_tags(node, drawing_context),
      process_tag_br(NULL, drawing_context)
    ),
    recursive = FALSE
  )

  # word wrapping corresponds to width_policy = "relative".
  if (isTRUE(drawing_context$word_wrap)) {
    bl_make_par_box(
      boxes, drawing_context$linespacing_pt, width_policy = "relative",
      hjust = drawing_context$halign
    )
  } else {
    bl_make_par_box(
      boxes, drawing_context$linespacing_pt, width_policy = "native",
      hjust = drawing_context$halign
    )
  }
}

process_tag_span <- function(node, drawing_context) {
  attr <- attributes(node)
  drawing_context <- set_style(drawing_context, attr$style)

  process_tags(node, drawing_context)
}

process_tag_sup <- function(node, drawing_context) {
  # modify fontsize before processing style, to allow for manual overriding
  drawing_context <- set_context_gp(drawing_context, gpar(fontsize = 0.8*drawing_context$gp$fontsize))
  attr <- attributes(node)
  drawing_context <- set_style(drawing_context, attr$style)

  # move drawing half a character above baseline
  drawing_context$yoff_pt <- drawing_context$yoff_pt + drawing_context$ascent_pt / 2
  process_tags(node, drawing_context)
}

process_tag_sub <- function(node, drawing_context) {
  # modify fontsize before processing style, to allow for manual overriding
  drawing_context <- set_context_gp(drawing_context, gpar(fontsize = 0.8*drawing_context$gp$fontsize))
  attr <- attributes(node)
  drawing_context <- set_style(drawing_context, attr$style)

  # move drawing half a character below baseline
  drawing_context$yoff_pt <- drawing_context$yoff_pt - drawing_context$ascent_pt / 2
  process_tags(node, drawing_context)
}

dispatch_tag <- function(node, tag, drawing_context) {
  if (is.null(tag) || tag == "") {
    process_text(node, drawing_context)
  } else {
    switch(
      tag,
      "b"    = process_tag_b(node, drawing_context),
      "strong" = process_tag_b(node, drawing_context),
      "br"   = process_tag_br(node, drawing_context),
      "i"    = process_tag_i(node, drawing_context),
      "img"  = process_tag_img(node, drawing_context),
      "em"   = process_tag_i(node, drawing_context),
      "p"    = process_tag_p(node, drawing_context),
      "span" = process_tag_span(node, drawing_context),
      "sup"  = process_tag_sup(node, drawing_context),
      "sub"  = process_tag_sub(node, drawing_context),
      stop(
        paste0("gridtext has encountered a tag that isn't supported yet: <", tag, ">\n",
               "Only a very limited number of tags are currently supported."),
        call. = FALSE
      )
    )
  }
}


process_tags <- function(node, drawing_context) {
  tags <- names(node)
  boxes <- list()
  for (i in seq_along(node)) {
    boxes[[i]] <- dispatch_tag(node[[i]], tags[i], drawing_context)
  }
  unlist(boxes, recursive = FALSE)
}

#' Calculate text details for a given text label
#'
#' Calculate text details for a given text label
#' @param label Character vector containing the label. Can handle only one label at a time.
#' @param gp Grid graphical parameters defining the font (`fontfamily`, `fontface`, and
#'   `fontsize` should be defined).
#' @examples
#' text_details("Hello world!", grid::gpar(fontfamily = "", fontface = "plain", fontsize = 12))
#' text_details("Hello world!", grid::gpar(fontfamily = "", fontface = "plain", fontsize = 24))
#' text_details(
#'   "Hello world\nwith newline",
#'   grid::gpar(fontfamily = "", fontface = "plain", fontsize = 12)
#' )
#' @noRd
text_details <- function(label, gp = gpar()) {
  fontfamily <- gp$fontfamily %||% grid::get.gpar("fontfamily")$fontfamily
  font <- gp$font %||% grid::get.gpar("font")$font
  fontsize <- gp$fontsize %||% grid::get.gpar("fontsize")$fontsize

  devname <- names(grDevices::dev.cur())
  fontkey <- paste0(devname, fontfamily, font, fontsize)
  if (devname == "null device") {
    cache <- FALSE   # don't cache if no device open
  } else {
    cache <- TRUE
  }

  if (length(fontkey) != 1 || length(label) != 1) {
    stop("Function `text_details()` is not vectorized.", call. = FALSE)
  }

  # ascent and width depend on label and font
  l1 <- text_info(label, fontkey, fontfamily, font, fontsize, cache)
  # descent and space width depend only on font
  l2 <- font_info(fontkey, fontfamily, font, fontsize, cache)

  # concatenate, result is a list with four members, width_pt, ascent_pt, descent_pt, space_pt
  c(l1, l2)
}

font_info_cache <- new.env(parent = emptyenv())
font_info <- function(fontkey, fontfamily, font, fontsize, cache) {
  info <- font_info_cache[[fontkey]]

  if (is.null(info)) {
    descent_pt <- convertHeight(grobDescent(textGrob(
      label = "gjpqyQ",
      gp = gpar(
        fontsize = fontsize,
        fontfamily = fontfamily,
        font = font,
        cex = 1
      )
    )), "pt", valueOnly = TRUE)

    space_pt <- convertWidth(grobWidth(textGrob(
      label = " ",
      gp = gpar(
        fontsize = fontsize,
        fontfamily = fontfamily,
        font = font,
        cex = 1
      )
    )), "pt", valueOnly = TRUE)

    info <- list(descent_pt = descent_pt, space_pt = space_pt)

    if (cache) {
      font_info_cache[[fontkey]] <- info
    }
  }
  info
}

text_info_cache <- new.env(parent = emptyenv())
text_info <- function(label, fontkey, fontfamily, font, fontsize, cache) {
  key <- paste0(label, fontkey)
  info <- text_info_cache[[key]]

  if (is.null(info)) {
    ascent_pt <- convertHeight(grobHeight(textGrob(
      label = label,
      gp = gpar(
        fontsize = fontsize,
        fontfamily = fontfamily,
        font = font,
        cex = 1
      )
    )), "pt", valueOnly = TRUE)

    width_pt <- convertWidth(grobWidth(textGrob(
      label = label,
      gp = gpar(
        fontsize = fontsize,
        fontfamily = fontfamily,
        font = font,
        cex = 1
      )
    )), "pt", valueOnly = TRUE)

    info <- list(width_pt = width_pt, ascent_pt = ascent_pt)

    if (cache) {
      text_info_cache[[key]] <- info
    }
  }
  info
}

test_that("text_details() calculates info correctly", {
  # descent and space are independent of string
  gp1 <- gpar(fontfamily = "Helvetica", fontface = "plain", fontsize = 10)
  t1 <- text_details("abcd", gp = gp1)
  t2 <- text_details("gjqp", gp = gp1)
  expect_equal(t1$descent_pt, t2$descent_pt)
  expect_equal(t1$space_pt, t2$space_pt)

  # recalculating the same details gives same results (tests caching)
  t2 <- text_details("abcd", gp = gp1)
  expect_equal(t1$width_pt, t2$width_pt)
  expect_equal(t1$ascent_pt, t2$ascent_pt)
  expect_equal(t1$descent_pt, t2$descent_pt)
  expect_equal(t1$space_pt, t2$space_pt)

  # all parameters scale with font size
  gp2 <- gpar(fontfamily = "Helvetica", fontface = "plain", fontsize = 20)
  t2 <- text_details("abcd", gp = gp2)
  expect_equal(2 * t1$width_pt, t2$width_pt)
  expect_equal(2 * t1$ascent_pt, t2$ascent_pt)
  expect_equal(2 * t1$descent_pt, t2$descent_pt)
  expect_equal(2 * t1$space_pt, t2$space_pt)

  # parameters change with font
  gp2 <- gpar(fontfamily = "Times", fontface = "plain", fontsize = 10)
  t2 <- text_details("abcd", gp = gp2)
  expect_false(t1$width_pt == t2$width_pt)
  expect_false(t1$ascent_pt == t2$ascent_pt)
  expect_false(t1$descent_pt == t2$descent_pt)
  expect_false(t1$space_pt == t2$space_pt)

  # font details are identical to what we would get from an actual grob
  g <- textGrob("Qbcd", gp = gp1)
  t1 <- text_details("Qbcd", gp = gp1)
  expect_equal(t1$ascent_pt, convertHeight(grobHeight(g), "pt", valueOnly = TRUE))
  expect_equal(t1$width_pt, convertWidth(grobWidth(g), "pt", valueOnly = TRUE))
})

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

bl_make_null_box <- function(width_pt = 0, height_pt = 0) {
    .Call(`_gridtext_bl_make_null_box`, width_pt, height_pt)
}

bl_make_par_box <- function(node_list, vspacing_pt, width_policy = "native", hjust = NULL) {
    .Call(`_gridtext_bl_make_par_box`, node_list, vspacing_pt, width_policy, hjust)
}

bl_make_rect_box <- function(content, width_pt, height_pt, margin, padding, gp, content_hjust = 0, content_vjust = 1, width_policy = "fixed", height_policy = "fixed", r = 0) {
    .Call(`_gridtext_bl_make_rect_box`, content, width_pt, height_pt, margin, padding, gp, content_hjust, content_vjust, width_policy, height_policy, r)
}

bl_make_text_box <- function(label, gp, voff_pt = 0) {
    .Call(`_gridtext_bl_make_text_box`, label, gp, voff_pt)
}

bl_make_raster_box <- function(image, width_pt = 0, height_pt = 0, width_policy = "native", height_policy = "native", respect_aspect = TRUE, interpolate = TRUE, dpi = 150, gp = NULL) {
    .Call(`_gridtext_bl_make_raster_box`, image, width_pt, height_pt, width_policy, height_policy, respect_aspect, interpolate, dpi, gp)
}

bl_make_vbox <- function(node_list, width_pt = 0, hjust = 0, vjust = 1, width_policy = "native") {
    .Call(`_gridtext_bl_make_vbox`, node_list, width_pt, hjust, vjust, width_policy)
}

bl_make_regular_space_glue <- function(gp, stretch_ratio = 0.5, shrink_ratio = 0.333333) {
    .Call(`_gridtext_bl_make_regular_space_glue`, gp, stretch_ratio, shrink_ratio)
}

bl_make_forced_break_penalty <- function() {
    .Call(`_gridtext_bl_make_forced_break_penalty`)
}

bl_make_never_break_penalty <- function() {
    .Call(`_gridtext_bl_make_never_break_penalty`)
}

bl_box_width <- function(node) {
    .Call(`_gridtext_bl_box_width`, node)
}

bl_box_height <- function(node) {
    .Call(`_gridtext_bl_box_height`, node)
}

bl_box_ascent <- function(node) {
    .Call(`_gridtext_bl_box_ascent`, node)
}

bl_box_descent <- function(node) {
    .Call(`_gridtext_bl_box_descent`, node)
}

bl_box_voff <- function(node) {
    .Call(`_gridtext_bl_box_voff`, node)
}

bl_calc_layout <- function(node, width_pt = 0, height_pt = 0) {
    invisible(.Call(`_gridtext_bl_calc_layout`, node, width_pt, height_pt))
}

bl_place <- function(node, x_pt, y_pt) {
    invisible(.Call(`_gridtext_bl_place`, node, x_pt, y_pt))
}

bl_render <- function(node, x_pt = 0, y_pt = 0) {
    .Call(`_gridtext_bl_render`, node, x_pt, y_pt)
}

grid_renderer <- function() {
    .Call(`_gridtext_grid_renderer`)
}

grid_renderer_text <- function(gr, label, x, y, gp) {
    invisible(.Call(`_gridtext_grid_renderer_text`, gr, label, x, y, gp))
}

grid_renderer_text_details <- function(label, gp) {
    .Call(`_gridtext_grid_renderer_text_details`, label, gp)
}

grid_renderer_raster <- function(gr, image, x, y, width, height, interpolate = TRUE) {
    invisible(.Call(`_gridtext_grid_renderer_raster`, gr, image, x, y, width, height, interpolate))
}

grid_renderer_rect <- function(gr, x, y, width, height, gp, r = 0L) {
    invisible(.Call(`_gridtext_grid_renderer_rect`, gr, x, y, width, height, gp, r))
}

grid_renderer_collect_grobs <- function(gr) {
    .Call(`_gridtext_grid_renderer_collect_grobs`, gr)
}

unit_pt <- function(x) {
    .Call(`_gridtext_unit_pt`, x)
}

gpar_empty <- function() {
    .Call(`_gridtext_gpar_empty`)
}

text_grob <- function(label, x_pt = 0L, y_pt = 0L, gp = NULL, name = NULL) {
    .Call(`_gridtext_text_grob`, label, x_pt, y_pt, gp, name)
}

raster_grob <- function(image, x_pt = 0L, y_pt = 0L, width_pt = 0L, height_pt = 0L, interpolate = TRUE, gp = NULL, name = NULL) {
    .Call(`_gridtext_raster_grob`, image, x_pt, y_pt, width_pt, height_pt, interpolate, gp, name)
}

rect_grob <- function(x_pt = 0L, y_pt = 0L, width_pt = 0L, height_pt = 0L, gp = NULL, name = NULL) {
    .Call(`_gridtext_rect_grob`, x_pt, y_pt, width_pt, height_pt, gp, name)
}

roundrect_grob <- function(x_pt = 0L, y_pt = 0L, width_pt = 0L, height_pt = 0L, r_pt = 5L, gp = NULL, name = NULL) {
    .Call(`_gridtext_roundrect_grob`, x_pt, y_pt, width_pt, height_pt, r_pt, gp, name)
}

set_grob_coords <- function(grob, x, y) {
    .Call(`_gridtext_set_grob_coords`, grob, x, y)
}

test_that("image dimensions are used", {
  logo_file <- system.file("extdata", "Rlogo.png", package = "gridtext")
  logo <- png::readPNG(logo_file, native = FALSE)

  # default size policy is native for both height and width
  # dpi = 72.27 turns lengths in pixels to lengths in pt
  rb <- bl_make_raster_box(logo, dpi = 72.27)
  bl_calc_layout(rb, 100, 100)
  bl_place(rb, 30, 5)
  g <- bl_render(rb, 10, 20)

  img <- g[[1]]
  expect_identical(img$x, unit(40, "pt"))
  expect_identical(img$y, unit(25, "pt"))
  expect_equal(img$width, unit(ncol(logo), "pt"))
  expect_equal(img$height, unit(nrow(logo), "pt"))

  # test now with raster object
  logo2 <- as.raster(logo)
  rb <- bl_make_raster_box(logo2, dpi = 72.27)
  bl_calc_layout(rb, 100, 100)
  g <- bl_render(rb, 10, 20)

  img <- g[[1]]
  expect_identical(img$x, unit(10, "pt"))
  expect_identical(img$y, unit(20, "pt"))
  expect_equal(img$width, unit(ncol(logo), "pt"))
  expect_equal(img$height, unit(nrow(logo), "pt"))

  # test now with nativeRaster object
  logo3 <- png::readPNG(logo_file, native = TRUE)
  rb <- bl_make_raster_box(logo3, dpi = 72.27)
  bl_calc_layout(rb, 100, 100)
  g <- bl_render(rb, 10, 20)

  img <- g[[1]]
  expect_identical(img$x, unit(10, "pt"))
  expect_identical(img$y, unit(20, "pt"))
  expect_equal(img$width, unit(ncol(logo), "pt"))
  expect_equal(img$height, unit(nrow(logo), "pt"))

  # dimensions are reported correctly
  expect_equal(bl_box_width(rb), ncol(logo))
  expect_equal(bl_box_height(rb), nrow(logo))
  expect_equal(bl_box_ascent(rb), nrow(logo))
  expect_identical(bl_box_descent(rb), 0)
  expect_identical(bl_box_voff(rb), 0)

  m <- 1:10
  dim(m) <- 10

  expect_error(
    bl_make_raster_box(m),
    "Cannot extract image dimensions."
  )
})


test_that("size policies, respect_aspect = FALSE", {
  logo_file <- system.file("extdata", "Rlogo.png", package = "gridtext")
  logo <- png::readPNG(logo_file, native = TRUE)

  rb <- bl_make_raster_box(logo, width = 50, height = 80,
                                      width_policy = "fixed", height_policy = "fixed",
                                      respect_aspect = FALSE)
  bl_calc_layout(rb, 200, 100)
  g <- bl_render(rb, 10, 20)

  img <- g[[1]]
  expect_identical(img$x, unit(10, "pt"))
  expect_identical(img$y, unit(20, "pt"))
  expect_identical(img$width, unit(50, "pt"))
  expect_identical(img$height, unit(80, "pt"))

  rb <- bl_make_raster_box(logo, width = 50, height = 80,
                           width_policy = "relative", height_policy = "expand",
                           respect_aspect = FALSE)
  bl_calc_layout(rb, 200, 100)
  g <- bl_render(rb, 10, 20)

  img <- g[[1]]
  expect_identical(img$x, unit(10, "pt"))
  expect_identical(img$y, unit(20, "pt"))
  expect_identical(img$width, unit(100, "pt"))
  expect_identical(img$height, unit(100, "pt"))

  rb <- bl_make_raster_box(logo, width = 50, height = 80,
                           width_policy = "expand", height_policy = "relative",
                           respect_aspect = FALSE)
  bl_calc_layout(rb, 200, 100)
  g <- bl_render(rb, 10, 20)

  img <- g[[1]]
  expect_identical(img$x, unit(10, "pt"))
  expect_identical(img$y, unit(20, "pt"))
  expect_identical(img$width, unit(200, "pt"))
  expect_identical(img$height, unit(80, "pt"))

  rb <- bl_make_raster_box(logo, width = 50, height = 80,
                           width_policy = "fixed", height_policy = "native",
                           respect_aspect = FALSE)
  bl_calc_layout(rb, 200, 100)
  g <- bl_render(rb, 10, 20)

  img <- g[[1]]
  expect_identical(img$x, unit(10, "pt"))
  expect_identical(img$y, unit(20, "pt"))
  expect_identical(img$width, unit(50, "pt"))
  expect_equal(img$height, unit(50*nrow(logo)/ncol(logo), "pt"))

  rb <- bl_make_raster_box(logo, width = 50, height = 80,
                           width_policy = "native", height_policy = "fixed",
                           respect_aspect = FALSE)
  bl_calc_layout(rb, 200, 100)
  g <- bl_render(rb, 10, 20)

  img <- g[[1]]
  expect_identical(img$x, unit(10, "pt"))
  expect_identical(img$y, unit(20, "pt"))
  expect_equal(img$width, unit(80*ncol(logo)/nrow(logo), "pt"))
  expect_identical(img$height, unit(80, "pt"))
})


test_that("size policies, respect_aspect = TRUE", {
  logo_file <- system.file("extdata", "Rlogo.png", package = "gridtext")
  logo <- png::readPNG(logo_file, native = TRUE)

  rb <- bl_make_raster_box(logo, width = 50, height = 80,
                           width_policy = "fixed", height_policy = "fixed")
  bl_calc_layout(rb, 200, 100)
  g <- bl_render(rb, 10, 20)

  nr <- nrow(logo)
  nc <- ncol(logo)
  img_height <- 50*nr/nc
  yoff <- (80 - img_height)/2

  img <- g[[1]]
  expect_identical(img$x, unit(10, "pt"))
  expect_equal(img$y, unit(20 + yoff, "pt"))
  expect_identical(img$width, unit(50, "pt"))
  expect_equal(img$height, unit(img_height, "pt"))

  rb <- bl_make_raster_box(logo, width = 80, height = 50,
                           width_policy = "fixed", height_policy = "fixed")
  bl_calc_layout(rb, 200, 100)
  g <- bl_render(rb, 10, 20)

  nr <- nrow(logo)
  nc <- ncol(logo)
  img_width <- 50*nc/nr
  xoff <- (80 - img_width)/2

  img <- g[[1]]
  expect_equal(img$x, unit(10 + xoff, "pt"))
  expect_identical(img$y, unit(20, "pt"))
  expect_equal(img$width, unit(img_width, "pt"))
  expect_identical(img$height, unit(50, "pt"))
})

context("grid-renderer")

test_that("basic functioning", {
  r <- grid_renderer()
  g <- grid_renderer_collect_grobs(r)

  # without any grobs rendered, we get an empty list of class gList
  expect_equal(length(g), 0)
  expect_true(inherits(g, "gList"))

  # grobs get added in order
  grid_renderer_text(r, "abcd", 100, 100, gpar())
  grid_renderer_rect(r, 100, 100, 200, 200, gpar())
  g <- grid_renderer_collect_grobs(r)
  expect_equal(length(g), 2)
  expect_true(inherits(g, "gList"))
  expect_true(inherits(g[[1]], "text"))
  expect_true(inherits(g[[2]], "rect"))

  # internal state gets reset after calling collect_grobs()
  g <- grid_renderer_collect_grobs(r)
  expect_equal(length(g), 0)
  expect_true(inherits(g, "gList"))
})

test_that("smart rendering of rects", {
  r <- grid_renderer()
  # add normal rect
  grid_renderer_rect(r, 100, 100, 200, 200, gp = gpar())
  # add rect with rounded corners
  grid_renderer_rect(r, 100, 100, 200, 200, gp = gpar(), r = 5)
  # add rect that is invisible, gets removed automatically
  grid_renderer_rect(r, 100, 100, 200, 200, gp = gpar(col = NA))
  g <- grid_renderer_collect_grobs(r)
  expect_equal(length(g), 2)
  expect_true(inherits(g, "gList"))
  expect_true(inherits(g[[1]], "rect"))
  expect_true(inherits(g[[2]], "roundrect"))

  # more extensive testing variations for dropping unneeded rects
  grid_renderer_rect(r, 100, 100, 200, 200, gp = gpar(lty = 0))
  g <- grid_renderer_collect_grobs(r)
  expect_equal(length(g), 0)

  grid_renderer_rect(r, 100, 100, 200, 200, gp = gpar(col = NA, lty = 1))
  g <- grid_renderer_collect_grobs(r)
  expect_equal(length(g), 0)

  grid_renderer_rect(r, 100, 100, 200, 200, gp = gpar(col = "black", lty = 0))
  g <- grid_renderer_collect_grobs(r)
  expect_equal(length(g), 0)

  grid_renderer_rect(r, 100, 100, 200, 200, gp = gpar(fill = NA, lty = 0))
  g <- grid_renderer_collect_grobs(r)
  expect_equal(length(g), 0)

  grid_renderer_rect(r, 100, 100, 200, 200, gp = gpar(fill = NA, col = "black", lty = 0))
  g <- grid_renderer_collect_grobs(r)
  expect_equal(length(g), 0)

  grid_renderer_rect(r, 100, 100, 200, 200, gp = gpar(fill = NA, col = NA, lty = 1))
  g <- grid_renderer_collect_grobs(r)
  expect_equal(length(g), 0)
})

test_that("visual tests", {
  draw_grob <- function(g) {
    function() {
      grid.newpage()
      grid.draw(g)
      invisible()
    }
  }

  r <- grid_renderer()
  grid_renderer_text(r, "blue", 10, 400, gp = gpar(col = "blue", fontsize = 12))
  grid_renderer_text(r, "red bold", 20, 380, gp = gpar(col = "red", fontsize = 12, fontface = "bold"))
  grid_renderer_text(r, "roman", 30, 360, gp = gpar(fontsize = 12, fontfamily = "Times"))
  g <- grid_renderer_collect_grobs(r)
  expect_doppelganger("Text in different stylings", draw_grob(g))

  grid_renderer_rect(r, 100, 400, 200, 20, gp = gpar(col = "blue"))
  grid_renderer_rect(r, 100, 200, 300, 30, gp = gpar(fill = "cornsilk"), r = 8)
  grid_renderer_text(r, "text 1, square box blue", 100, 400, gp = gpar(fontsize = 20))
  grid_renderer_text(r, "text 2, rounded box filled", 100, 200, gp = gpar(fontsize = 20))
  g <- grid_renderer_collect_grobs(r)
  expect_doppelganger("Mixing text and boxes", draw_grob(g))

  logo_file <- system.file("extdata", "Rlogo.png", package = "gridtext")
  logo <- png::readPNG(logo_file, native = TRUE)
  width <- ncol(logo)
  height <- nrow(logo)
  grid_renderer_raster(r, logo, 10, 10, width, height)
  g <- grid_renderer_collect_grobs(r)
  expect_doppelganger("Rendering raster data", draw_grob(g))
})


test_that("text details are calculated correctly", {
  gp = gpar(fontsize = 20)
  td <- text_details("abcd", gp)

  td2 <- grid_renderer_text_details("abcd", gp)
  expect_identical(td, td2)
})

test_that("vertical stacking works", {
  nb <- bl_make_null_box()
  rb1 <- bl_make_rect_box(nb, 100, 100, rep(0, 4), rep(0, 4), gp = gpar())
  rb2 <- bl_make_rect_box(nb, 50, 50, rep(10, 4), rep(0, 4), gp = gpar())
  rb3 <- bl_make_rect_box(nb, 50, 10, rep(0, 4), rep(0, 4), gp = gpar(), width_policy = "expand")

  vb <- bl_make_vbox(list(rb1, rb2, rb3), width = 200, hjust = 0, vjust = 0, width_policy = "fixed")

  bl_calc_layout(vb, 0, 0)
  bl_place(vb, 0, 0)

  expect_identical(bl_box_width(vb), 200)
  expect_identical(bl_box_height(vb), 160)
  expect_identical(bl_box_voff(vb), 0)

  g <- bl_render(vb, 200, 100)

  out1 <- g[[1]]
  expect_identical(out1$x, unit(200, "pt"))
  expect_identical(out1$y, unit(100 + 10 + 50, "pt"))

  out2 <- g[[2]]
  expect_identical(out2$x, unit(210, "pt"))
  expect_identical(out2$y, unit(100 + 10 + 10, "pt"))

  out3 <- g[[3]]
  expect_identical(out3$x, unit(200, "pt"))
  expect_identical(out3$y, unit(100, "pt"))
  expect_identical(out3$width, unit(200, "pt"))

  # alternatve hjust, vjust, x, y
  vb <- bl_make_vbox(list(rb1, rb2, rb3), width = 200, hjust = 1, vjust = 1, width_policy = "fixed")

  bl_calc_layout(vb, 0, 0)
  bl_place(vb, 15, 27)

  expect_identical(bl_box_width(vb), 200)
  expect_identical(bl_box_height(vb), 160)

  g <- bl_render(vb, 200, 100)

  out1 <- g[[1]]
  expect_identical(out1$x, unit(15 + 0, "pt"))
  expect_identical(out1$y, unit(27 - 60 + 10 + 50, "pt"))

  out2 <- g[[2]]
  expect_identical(out2$x, unit(15 + 10, "pt"))
  expect_identical(out2$y, unit(27 - 60 + 10 + 10, "pt"))

  out3 <- g[[3]]
  expect_identical(out3$x, unit(15 + 0, "pt"))
  expect_identical(out3$y, unit(27 - 60, "pt"))
  expect_identical(out3$width, unit(200, "pt"))
})


test_that("size policies", {
  nb <- bl_make_null_box()
  rb1 <- bl_make_rect_box(nb, 100, 100, rep(0, 4), rep(0, 4), gp = gpar())
  rb2 <- bl_make_rect_box(nb, 50, 50, rep(10, 4), rep(0, 4), gp = gpar())
  vb <- bl_make_vbox(list(rb1, rb2), width = 200, hjust = 0.5, vjust = 0.5, width_policy = "native")

  bl_calc_layout(vb, 0, 0)
  expect_identical(bl_box_width(vb), 100)
  expect_identical(bl_box_height(vb), 150)

  vb <- bl_make_vbox(list(rb1, rb2), width = 200, hjust = 0.5, vjust = 0.5, width_policy = "relative")

  bl_calc_layout(vb, 70, 0)
  expect_identical(bl_box_width(vb), 140)
  expect_identical(bl_box_height(vb), 150)

  vb <- bl_make_vbox(list(rb1, rb2), width = 200, hjust = 0.5, vjust = 0.5, width_policy = "expand")

  bl_calc_layout(vb, 300, 0)
  expect_identical(bl_box_width(vb), 300)
  expect_identical(bl_box_height(vb), 150)
})

test_that("vertical offset is ignored in vertical stacking", {
  tb1 <- bl_make_text_box("string1", gp = gpar(fontsize = 10))
  tb2 <- bl_make_text_box("string2", gp = gpar(fontsize = 20), voff = -10)
  tb3 <- bl_make_text_box("string2", gp = gpar(fontsize = 20), voff = 0)
  tb4 <- bl_make_text_box("string3", gp = gpar(fontsize = 15))
  vb1 <- bl_make_vbox(list(tb1, tb2, tb4), hjust = 0, vjust = 0)
  bl_calc_layout(vb1, 100, 100)
  bl_place(vb1, 17, 24)
  vb2 <- bl_make_vbox(list(tb1, tb3, tb4), hjust = 0, vjust = 0)
  bl_calc_layout(vb2, 100, 100)
  bl_place(vb2, 17, 24)
  g1 <- bl_render(vb1, 0, 0)
  g2 <- bl_render(vb2, 0, 0)

  extract <- function(x, name) {x[[name]]}

  expect_identical(
    lapply(g1, extract, name = "x"),
    lapply(g2, extract, name = "x")
  )

  expect_identical(
    lapply(g1, extract, name = "y"),
    lapply(g2, extract, name = "y")
  )

  expect_identical(
    lapply(g1, extract, name = "label"),
    lapply(g2, extract, name = "label")
  )
})

test_that("alignment of content", {
  nb <- bl_make_null_box()
  cb <- bl_make_rect_box(nb, 20, 10, c(0, 0, 0, 0), c(0, 0, 0, 0), gp = gpar())

  rb <- bl_make_rect_box(cb, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar())
  bl_calc_layout(rb, 0, 0)
  g <- bl_render(rb, 100, 200)

  # placement of outer box depends on margins
  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  expect_identical(outer$width, unit(400 - 2 - 8, "pt"))
  expect_identical(outer$height, unit(600 - 1 - 4, "pt"))

  # placement of inner box depends on margins, padding, justification, and inner size
  inner <- g[[2]]
  expect_identical(inner$x, unit(100 + 8 + 128, "pt"))
  expect_identical(inner$y, unit(200 + 600 - 1 - 16 - 10, "pt"))

  rb <- bl_make_rect_box(cb, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
                                    content_hjust = 1, content_vjust = 0)
  bl_calc_layout(rb, 0, 0)
  g <- bl_render(rb, 100, 200)
  inner <- g[[2]]
  expect_identical(inner$x, unit(100 + 400 - 2 - 32 - 20, "pt"))
  expect_identical(inner$y, unit(200 + 4 + 64, "pt"))
})


test_that("size policies", {
  nb <- bl_make_null_box()
  cb <- bl_make_rect_box(nb, 20, 10, c(0, 0, 0, 0), c(0, 0, 0, 0), gp = gpar())

  rb <- bl_make_rect_box(
    cb, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "expand", height_policy = "relative"
  )
  bl_calc_layout(rb, 100, 50)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  expect_identical(outer$width, unit(100 - 2 - 8, "pt"))
  expect_identical(outer$height, unit(300 - 1 - 4, "pt"))
  inner <- g[[2]]
  expect_identical(inner$x, unit(100 + 8 + 128, "pt"))
  expect_identical(inner$y, unit(200 + 300 - 1 - 16 - 10, "pt"))

  rb <- bl_make_rect_box(
    cb, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "relative", height_policy = "expand"
  )
  bl_calc_layout(rb, 50, 300)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  expect_identical(outer$width, unit(200 - 2 - 8, "pt"))
  expect_identical(outer$height, unit(300 - 1 - 4, "pt"))
  inner <- g[[2]]
  expect_identical(inner$x, unit(100 + 8 + 128, "pt"))
  expect_identical(inner$y, unit(200 + 300 - 1 - 16 - 10, "pt"))

  rb <- bl_make_rect_box(
    cb, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "native", height_policy = "native"
  )
  bl_calc_layout(rb, 50, 300)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  # native width/height now depends on padding, not on margin
  expect_identical(outer$width, unit(20 + 32 + 128, "pt"))
  expect_identical(outer$height, unit(10 + 16 + 64, "pt"))
  inner <- g[[2]]
  expect_identical(inner$x, unit(100 + 8 + 128, "pt"))
  expect_identical(inner$y, unit(200 + 4 + 64, "pt"))

  rb <- bl_make_rect_box(
    cb, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "native", height_policy = "relative"
  )
  bl_calc_layout(rb, 50, 50)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  expect_identical(outer$width, unit(20 + 32 + 128, "pt"))
  expect_identical(outer$height, unit(300 - 1 - 4, "pt"))
  inner <- g[[2]]
  expect_identical(inner$x, unit(100 + 8 + 128, "pt"))
  expect_identical(inner$y, unit(200 + 300 - 1 - 16 - 10, "pt"))

  rb <- bl_make_rect_box(
    cb, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "native", height_policy = "expand"
  )
  bl_calc_layout(rb, 50, 300)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  expect_identical(outer$width, unit(20 + 32 + 128, "pt"))
  expect_identical(outer$height, unit(300 - 1 - 4, "pt"))
  inner <- g[[2]]
  expect_identical(inner$x, unit(100 + 8 + 128, "pt"))
  expect_identical(inner$y, unit(200 + 300 - 1 - 16 - 10, "pt"))

  rb <- bl_make_rect_box(
    cb, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "native", height_policy = "fixed"
  )
  bl_calc_layout(rb, 50, 300)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  expect_identical(outer$width, unit(20 + 32 + 128, "pt"))
  expect_identical(outer$height, unit(600 - 1 - 4, "pt"))
  inner <- g[[2]]
  expect_identical(inner$x, unit(100 + 8 + 128, "pt"))
  expect_identical(inner$y, unit(200 + 600 - 1 - 16 - 10, "pt"))

  rb <- bl_make_rect_box(
    cb, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "fixed", height_policy = "native"
  )
  bl_calc_layout(rb, 50, 300)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  expect_identical(outer$width, unit(400 - 2 - 8, "pt"))
  expect_identical(outer$height, unit(10 + 16 + 64, "pt"))
  inner <- g[[2]]
  expect_identical(inner$x, unit(100 + 8 + 128, "pt"))
  expect_identical(inner$y, unit(200 + 4 + 64, "pt"))

  # native size policies with no content
  rb <- bl_make_rect_box(
    NULL, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "native", height_policy = "native"
  )
  bl_calc_layout(rb, 50, 300)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  # native width/height now depends only on padding, since content size is 0
  expect_identical(outer$width, unit(32 + 128, "pt"))
  expect_identical(outer$height, unit(16 + 64, "pt"))

  rb <- bl_make_rect_box(
    NULL, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "native", height_policy = "fixed"
  )
  bl_calc_layout(rb, 50, 300)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  expect_identical(outer$width, unit(32 + 128, "pt"))
  expect_identical(outer$height, unit(600 - 1 - 4, "pt"))

  rb <- bl_make_rect_box(
    NULL, 400, 600, c(1, 2, 4, 8), c(16, 32, 64, 128), gp = gpar(),
    width_policy = "fixed", height_policy = "native"
  )
  bl_calc_layout(rb, 50, 300)
  g <- bl_render(rb, 100, 200)

  outer <- g[[1]]
  expect_identical(outer$x, unit(100 + 8, "pt"))
  expect_identical(outer$y, unit(200 + 4, "pt"))
  expect_identical(outer$width, unit(400 - 2 - 8, "pt"))
  expect_identical(outer$height, unit(16 + 64, "pt"))

})

test_that("unit_pt", {
  expect_equal(
    unit_pt(10),
    grid::unit(10, "pt")
  )

  expect_identical(
    unit_pt(1:10),
    grid::unit(1:10, "pt")
  )
})

test_that("gpar_empty", {
  expect_identical(
    gpar_empty(),
    grid::gpar()
  )
})

test_that("text_grob", {
  # basic functionality, gp is set to gpar() if not provided
  expect_identical(
    text_grob("test", 10, 20, name = "abc"),
    textGrob(
      "test",
      x = unit(10, "pt"), y = unit(20, "pt"),
      hjust = 0, vjust = 0,
      gp = gpar(),
      name = "abc"
    )
  )

  # basic functionality, x and y are set to 0 if not provided
  expect_identical(
    text_grob("test", name = "abc"),
    textGrob(
      "test",
      x = unit(0, "pt"), y = unit(0, "pt"),
      hjust = 0, vjust = 0,
      gp = gpar(),
      name = "abc"
    )
  )

  # gp is set as requested
  gp <- gpar(col = "blue", fill = "red")
  expect_identical(
    text_grob("test", 10, 20, gp = gp, name = "abc"),
    textGrob(
      "test",
      x = unit(10, "pt"), y = unit(20, "pt"),
      hjust = 0, vjust = 0,
      gp = gp,
      name = "abc"
    )
  )

  # if no name is provided, different names are assigned
  g1 <- text_grob("test")
  g2 <- text_grob("test")
  expect_false(identical(g1$name, g2$name))

  # function is not vectorized
  expect_error(
    text_grob(c("test", "test"), 10, 20),
    "not vectorized"
  )

  expect_error(
    text_grob("test", 1:5, 20),
    "not vectorized"
  )

  expect_error(
    text_grob("test", 10, 1:5),
    "not vectorized"
  )

  # arguments of length 0 are also disallowed
  expect_error(
    text_grob("test", numeric(0), 5),
    "not vectorized"
  )
})

test_that("raster_grob", {
  # basic functionality
  image <- matrix(0:1, ncol = 5, nrow = 4)

  expect_identical(
    raster_grob(image, 10, 20, 50, 40, gp = gpar(), name = "abc"),
    rasterGrob(
      image,
      x = unit(10, "pt"), y = unit(20, "pt"),
      width = unit(50, "pt"), height = unit(40, "pt"),
      hjust = 0, vjust = 0,
      interpolate = TRUE,
      gp = gpar(),
      name = "abc"
    )
  )

  # interpolate is set as requested, gp default is NULL
  expect_identical(
    raster_grob(image, 10, 20, 50, 40, interpolate = FALSE, name = "abc"),
    rasterGrob(
      image,
      x = unit(10, "pt"), y = unit(20, "pt"),
      width = unit(50, "pt"), height = unit(40, "pt"),
      hjust = 0, vjust = 0,
      interpolate = FALSE,
      gp = NULL,
      name = "abc"
    )
  )

  # if no name is provided, different names are assigned
  g1 <- raster_grob(image)
  g2 <- raster_grob(image)
  expect_false(identical(g1$name, g2$name))

  # function is not vectorized
  expect_error(
    raster_grob(image, c(10, 20), 20, 100, 140),
    "not vectorized"
  )

  expect_error(
    raster_grob(image, 10, numeric(0), 100, 140),
    "not vectorized"
  )
})


test_that("rect_grob", {
  # basic functionality, gp is set to gpar() if not provided
  expect_identical(
    rect_grob(10, 20, 100, 140, name = "abc"),
    rectGrob(
      x = unit(10, "pt"), y = unit(20, "pt"),
      width = unit(100, "pt"), height = unit(140, "pt"),
      hjust = 0, vjust = 0,
      gp = gpar(),
      name = "abc"
    )
  )

  # gp is set as requested
  gp <- gpar(col = "blue", fill = "red")
  expect_identical(
    rect_grob(10, 20, 100, 140, gp = gp, name = "abc"),
    rectGrob(
      x = unit(10, "pt"), y = unit(20, "pt"),
      width = unit(100, "pt"), height = unit(140, "pt"),
      hjust = 0, vjust = 0,
      gp = gp,
      name = "abc"
    )
  )

  # if no name is provided, different names are assigned
  g1 <- rect_grob()
  g2 <- rect_grob()
  expect_false(identical(g1$name, g2$name))

  # function is not vectorized
  expect_error(
    rect_grob(c(10, 20), 20, 100, 140),
    "not vectorized"
  )

  expect_error(
    rect_grob(10, numeric(0), 100, 140),
    "not vectorized"
  )
})

test_that("roundrect_grob", {
  # basic functionality, gp is set to gpar() if not provided
  expect_identical(
    roundrect_grob(10, 20, 100, 140, 10, name = "abc"),
    roundrectGrob(
      x = unit(10, "pt"), y = unit(20, "pt"),
      width = unit(100, "pt"), height = unit(140, "pt"),
      r = unit(10, "pt"),
      just = c(0, 0),
      gp = gpar(),
      name = "abc"
    )
  )

  # gp is set as requested
  gp <- gpar(col = "blue", fill = "red")
  expect_identical(
    roundrect_grob(10, 20, 100, 140, 20, gp = gp, name = "abc"),
    roundrectGrob(
      x = unit(10, "pt"), y = unit(20, "pt"),
      width = unit(100, "pt"), height = unit(140, "pt"),
      r = unit(20, "pt"),
      just = c(0, 0),
      gp = gp,
      name = "abc"
    )
  )

  # if no name is provided, different names are assigned
  g1 <- roundrect_grob()
  g2 <- roundrect_grob()
  expect_false(identical(g1$name, g2$name))

  # function is not vectorized
  expect_error(
    roundrect_grob(c(10, 20), 20, 100, 140, 20),
    "not vectorized"
  )

  expect_error(
    roundrect_grob(10, numeric(0), 100, 140, 20),
    "not vectorized"
  )
})


test_that("set_grob_coords", {
  g <- list(x = 0, y = 0)

  # setting coords as numbers
  expect_identical(
    set_grob_coords(g, x = 20, y = 40),
    list(x = 20, y = 40)
  )

  # setting coords as units
  expect_identical(
    set_grob_coords(g, x = unit_pt(20), y = unit_pt(40)),
    list(x = unit_pt(20), y = unit_pt(40))
  )
})

test_that("basic features", {
  # null box with no extent
  nb <- bl_make_null_box()
  expect_identical(bl_box_width(nb), 0)
  expect_identical(bl_box_height(nb), 0)
  expect_identical(bl_box_ascent(nb), 0)
  expect_identical(bl_box_descent(nb), 0)
  expect_identical(bl_box_voff(nb), 0)

  g <- bl_render(nb, 100, 200)
  expect_identical(length(g), 0L)

  # null box with defined extent
  nb <- bl_make_null_box(100, 200)
  expect_identical(bl_box_width(nb), 100)
  expect_identical(bl_box_height(nb), 200)
  expect_identical(bl_box_ascent(nb), 200)
  expect_identical(bl_box_descent(nb), 0)
  expect_identical(bl_box_voff(nb), 0)

  g <- bl_render(nb, 100, 200)
  expect_identical(length(g), 0L)

  # null box transmits its extent to enclosing rect box
  rb <- bl_make_rect_box(
    nb, 0, 0, margin = rep(0, 4), padding = rep(0, 4),
    gp = gpar(), width_policy = "native", height_policy = "native"
  )
  bl_calc_layout(rb, 0, 0)
  g <- bl_render(rb, 100, 200)
  outer <- g[[1]]
  expect_identical(outer$x, unit(100, "pt"))
  expect_identical(outer$y, unit(200, "pt"))
  expect_identical(outer$width, unit(100, "pt"))
  expect_identical(outer$height, unit(200, "pt"))
})

# various functions to help with grid functionality

# from: https://github.com/thomasp85/ggforce/blob/cba71550606d18b4f4b245cb097aee5eeeec52a8/R/textbox.R#L290-L295
# code taken with permission (https://twitter.com/thomasp85/status/1160989815657119747)
with_unit <- function(x, default) {
  if (!is.null(x) && !is.unit(x)) {
    x <- unit(x, default)
  }
  x
}

# calculate the current width of a grob, in pt
# @flip are width and height flipped?
# @convert_null should null values be converted or kept as they are?
current_width_pt <- function(grob = NULL, width = NULL, flip = FALSE, convert_null = TRUE) {
  if (is.null(width)) {
    if (isTRUE(convert_null)) {
      width <- unit(1, 'npc')
    } else {
      return(NULL)
    }
  }

  if (isTRUE(flip)) {
    convert <- convertHeight
  } else {
    convert <- convertWidth
  }

  if (is.null(grob$vp)) {
    width_pt <- convert(width, 'pt', TRUE)
  } else {
    # If the grob has its own viewport then we need to push it and
    # afterwards pop it. For this to work in the general case
    # (stacked viewports, etc), we need to keep track of the depth
    # of the current viewport stack and pop appropriately.
    n <- current.vpPath()$n %||% 0
    pushViewport(grob$vp)
    width_pt <- convert(width, 'pt', TRUE)
    popViewport(current.vpPath()$n - n)
  }

  width_pt
}

# calculate the current height of a grob, in pt
current_height_pt <- function(grob = NULL, height = NULL, flip = FALSE, convert_null = TRUE) {
  if (is.null(height)) {
    if (isTRUE(convert_null)) {
      height <- unit(1, 'npc')
    } else {
      return(NULL)
    }
  }

  if (isTRUE(flip)) {
    convert <- convertWidth
  } else {
    convert <- convertHeight
  }

  if (is.null(grob$vp)) {
    height_pt <- convert(height, 'pt', TRUE)
  } else {
    # If the grob has its own viewport then we need to push it and
    # afterwards pop it. For this to work in the general case
    # (stacked viewports, etc), we need to keep track of the depth
    # of the current viewport stack and pop appropriately.
    n <- current.vpPath()$n %||% 0
    pushViewport(grob$vp)
    height_pt <- convert(height, 'pt', TRUE)
    popViewport(current.vpPath()$n - n)
  }

  height_pt
}

# Parse css
#
# A very simple css parser that can parse `key:value;` pairs.
#
# @param text The css text to parse
parse_css <- function(text) {
  # break into separate lines; for now, ignore the possibility of
  # quoted or escaped semicolon
  lines <- strsplit(text, ";", fixed = TRUE)[[1]]

  # parse each line and return list of key--value pairs
  unlist(lapply(lines, parse_css_line), recursive = FALSE)
}

parse_css_line <- function(line) {
  pattern <- "\\s*(\\S+)\\s*:\\s*(\"(.*)\"|'(.*)'|(\\S*))\\s*"
  m <- attributes(regexpr(pattern, line, perl = TRUE))
  if (m$capture.start[1] > 0) {
    key <- substr(line, m$capture.start[1], m$capture.start[1] + m$capture.length[1] - 1)
  } else key <- NULL

  if (m$capture.start[3] > 0) {
    value <- substr(line, m$capture.start[3], m$capture.start[3] + m$capture.length[3] - 1)
  } else if (m$capture.start[4] > 0) {
    value <- substr(line, m$capture.start[4], m$capture.start[4] + m$capture.length[4] - 1)
  } else if (m$capture.start[5] > 0) {
    value <- substr(line, m$capture.start[5], m$capture.start[5] + m$capture.length[5] - 1)
  } else value <- NULL

  if (is.null(key)) list()
  else list2(!!key := value)
}

parse_css_unit <- function(x) {
  pattern <- "^((-?\\d+\\.?\\d*)(%|[a-zA-Z]+)|(0))$"
  m <- attributes(regexpr(pattern, x, perl = TRUE))
  if (m$capture.start[4] > 0) {
    # matched null value
    return(list(value = 0, unit = "pt"))
  } else {
    if (m$capture.start[2] > 0) {
      value <- as.numeric(
        substr(x, m$capture.start[2], m$capture.start[2] + m$capture.length[2] - 1)
      )
      if (m$capture.start[3] > 0) {
        unit <- substr(x, m$capture.start[3], m$capture.start[3] + m$capture.length[3] - 1)
        return(list(value = value, unit = unit))
      }
    }
  }
  stop(paste0("The string '", x, "' does not represent a valid CSS unit."), call. = FALSE)
}

convert_css_unit_pt <- function(x) {
  u <- parse_css_unit(x)
  switch(
    u$unit,
    pt = u$value,
    px = (72/96)*u$value,
    `in` = 72*u$value,
    cm = (72/2.54)*u$value,
    mm = (72/25.4)*u$value,
    stop(paste0("Cannot convert ", u$value, u$unit, " to pt."), call. = FALSE)
  )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/textbox-grob.R
\name{textbox_grob}
\alias{textbox_grob}
\title{Draw formatted multi-line text with word wrap}
\usage{
textbox_grob(
  text,
  x = NULL,
  y = NULL,
  width = unit(1, "npc"),
  height = NULL,
  minwidth = NULL,
  maxwidth = NULL,
  minheight = NULL,
  maxheight = NULL,
  hjust = 0.5,
  vjust = 0.5,
  halign = 0,
  valign = 1,
  default.units = "npc",
  margin = unit(c(0, 0, 0, 0), "pt"),
  padding = unit(c(0, 0, 0, 0), "pt"),
  r = unit(0, "pt"),
  orientation = c("upright", "left-rotated", "right-rotated", "inverted"),
  name = NULL,
  gp = gpar(),
  box_gp = gpar(col = NA),
  vp = NULL,
  use_markdown = TRUE
)
}
\arguments{
\item{text}{Character vector containing Markdown/HTML string to draw.}

\item{x, y}{Unit objects specifying the location of the reference point.
If set to \code{NULL} (the default), these values are chosen based on the
values of \code{hjust} and \code{vjust} such that the box is appropriately
justified in the enclosing viewport.}

\item{width, height}{Unit objects specifying width and height of the
grob. A value of \code{NULL} means take up exactly the space necessary
to render all content. Use a value of \code{unit(1, "npc")} to have the
box take up all available space.}

\item{minwidth, minheight, maxwidth, maxheight}{Min and max values for
width and height. Set to \code{NULL} to impose neither a minimum nor
a maximum. Note: \code{minheight} and \code{maxheight} do not work if \code{width = NULL}.}

\item{hjust, vjust}{Numerical values specifying the justification
of the text box relative to the reference point defined by \code{x} and \code{y}. These
justification parameters are specified in the internal reference frame of
the text box, so that, for example, \code{hjust} adjusts the vertical
justification when the text box is left- or right-rotated.}

\item{halign, valign}{Numerical values specifying the justification of the text
inside the text box.}

\item{default.units}{Units of \code{x}, \code{y}, \code{width}, \code{height}, \code{minwidth},
\code{minheight}, \code{maxwidth}, \code{maxheight} if these are provided only as
numerical values.}

\item{margin, padding}{Unit vectors of four elements each indicating the
margin and padding around each text label in the order top, right,
bottom, left. Margins are drawn outside the enclosing box (if any),
and padding is drawn inside. To avoid rendering artifacts, it is best
to specify these values in absolute units (such as points, mm, or inch)
rather than in relative units (such as npc).}

\item{r}{The radius of the rounded corners. To avoid rendering artifacts,
it is best to specify this in absolute units (such as points, mm, or inch)
rather than in relative units (such as npc).}

\item{orientation}{Orientation of the box. Allowed values are \code{"upright"},
\code{"left-rotated"}, \code{"right-rotated"}, and \code{"inverted"}, corresponding to
a rotation by 0, 90, 270, and 180 degrees counter-clockwise, respectively.}

\item{name}{Name of the grob.}

\item{gp}{Other graphical parameters for drawing.}

\item{box_gp}{Graphical parameters for the enclosing box around each text label.}

\item{vp}{Viewport.}

\item{use_markdown}{Should the \code{text} input be treated as markdown?}
}
\value{
A grid \code{\link{grob}} that represents the formatted text.
}
\description{
The function \code{textbox_grob()} is intended to render multi-line text
labels that require automatic word wrapping. It is similar to
\code{\link[=richtext_grob]{richtext_grob()}}, but there are a few important differences. First,
while \code{\link[=richtext_grob]{richtext_grob()}} is vectorized, \code{textbox_grob()} is not. It
can draw only a single text box at a time. Second, \code{textbox_grob()}
doesn't support rendering the text box at arbitrary angles. Only
four different orientations are supported, corresponding to a
rotation by 0, 90, 180, and 270 degrees.
}
\examples{
library(grid)
g <- textbox_grob(
  "**The quick brown fox jumps over the lazy dog.**<br><br>
  The quick brown fox jumps over the lazy dog.
  The **quick <span style='color:brown;'>brown fox</span>** jumps over the lazy dog.
  The quick brown fox jumps over the lazy dog.",
  x = unit(0.5, "npc"), y = unit(0.7, "npc"), halign = 0, valign = 1,
  gp = gpar(fontsize = 15),
  box_gp = gpar(col = "black", fill = "lightcyan1"),
  r = unit(5, "pt"),
  padding = unit(c(10, 10, 10, 10), "pt"),
  margin = unit(c(0, 10, 0, 10), "pt")
)
grid.newpage()
grid.draw(g)

# internal vs. external alignment
g1 <- textbox_grob(
  "The quick brown fox jumps over the lazy dog.",
  hjust = 0, vjust = 1, halign = 0, valign = 1,
  width = unit(1.5, "inch"), height = unit(1.5, "inch"),
  box_gp = gpar(col = "black", fill = "cornsilk"),
  padding = unit(c(2, 2, 2, 2), "pt"),
  margin = unit(c(5, 5, 5, 5), "pt")
)
g2 <- textbox_grob(
  "The quick brown fox jumps over the lazy dog.",
  hjust = 1, vjust = 1, halign = 0.5, valign = 0.5,
  width = unit(1.5, "inch"), height = unit(1.5, "inch"),
  box_gp = gpar(col = "black", fill = "cornsilk"),
  padding = unit(c(2, 2, 2, 2), "pt"),
  margin = unit(c(5, 5, 5, 5), "pt")
)
g3 <- textbox_grob(
  "The quick brown fox jumps over the lazy dog.",
  hjust = 0, vjust = 0, halign = 1, valign = 1,
  width = unit(1.5, "inch"), height = unit(1.5, "inch"),
  box_gp = gpar(col = "black", fill = "cornsilk"),
  padding = unit(c(2, 2, 2, 2), "pt"),
  margin = unit(c(5, 5, 5, 5), "pt")
)
g4 <- textbox_grob(
  "The quick brown fox jumps over the lazy dog.",
  hjust = 1, vjust = 0, halign = 0, valign = 0,
  width = unit(1.5, "inch"), height = unit(1.5, "inch"),
  box_gp = gpar(col = "black", fill = "cornsilk"),
  padding = unit(c(2, 2, 2, 2), "pt"),
  margin = unit(c(5, 5, 5, 5), "pt")
)
grid.newpage()
grid.draw(g1)
grid.draw(g2)
grid.draw(g3)
grid.draw(g4)

# internal vs. external alignment, with rotated boxes
g1 <- textbox_grob(
  "The quick brown fox jumps over the lazy dog.",
  hjust = 1, vjust = 1, halign = 0, valign = 1,
  width = unit(1.5, "inch"), height = unit(1.5, "inch"),
  orientation = "left-rotated",
  box_gp = gpar(col = "black", fill = "cornsilk"),
  padding = unit(c(2, 2, 2, 2), "pt"),
  margin = unit(c(5, 5, 5, 5), "pt")
)
g2 <- textbox_grob(
  "The quick brown fox jumps over the lazy dog.",
  hjust = 0, vjust = 1, halign = 0.5, valign = 0.5,
  width = unit(1.5, "inch"), height = unit(1.5, "inch"),
  orientation = "right-rotated",
  box_gp = gpar(col = "black", fill = "cornsilk"),
  padding = unit(c(2, 2, 2, 2), "pt"),
  margin = unit(c(5, 5, 5, 5), "pt")
)
g3 <- textbox_grob(
  "The quick brown fox jumps over the lazy dog.",
  hjust = 1, vjust = 1, halign = 1, valign = 1,
  width = unit(1.5, "inch"), height = unit(1.5, "inch"),
  orientation = "inverted",
  box_gp = gpar(col = "black", fill = "cornsilk"),
  padding = unit(c(2, 2, 2, 2), "pt"),
  margin = unit(c(5, 5, 5, 5), "pt")
)
g4 <- textbox_grob(
  "The quick brown fox jumps over the lazy dog.",
  hjust = 1, vjust = 0, halign = 0, valign = 0,
  width = unit(1.5, "inch"), height = unit(1.5, "inch"),
  orientation = "upright",
  box_gp = gpar(col = "black", fill = "cornsilk"),
  padding = unit(c(2, 2, 2, 2), "pt"),
  margin = unit(c(5, 5, 5, 5), "pt")
)
grid.newpage()
grid.draw(g1)
grid.draw(g2)
grid.draw(g3)
grid.draw(g4)
}
\seealso{
\code{\link[=richtext_grob]{richtext_grob()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gridtext.R
\docType{package}
\name{gridtext}
\alias{gridtext}
\title{Improved text rendering support for grid graphics}
\description{
The gridtext package provides two new grobs, \code{\link[=richtext_grob]{richtext_grob()}} and
\code{\link[=textbox_grob]{textbox_grob()}}, which support drawing of formatted text labels and
formatted text boxes, respectively.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/richtext-grob.R
\name{richtext_grob}
\alias{richtext_grob}
\title{Draw formatted text labels}
\usage{
richtext_grob(
  text,
  x = unit(0.5, "npc"),
  y = unit(0.5, "npc"),
  hjust = 0.5,
  vjust = 0.5,
  halign = hjust,
  valign = vjust,
  rot = 0,
  default.units = "npc",
  margin = unit(c(0, 0, 0, 0), "pt"),
  padding = unit(c(0, 0, 0, 0), "pt"),
  r = unit(0, "pt"),
  align_widths = FALSE,
  align_heights = FALSE,
  name = NULL,
  gp = gpar(),
  box_gp = gpar(col = NA),
  vp = NULL,
  use_markdown = TRUE,
  debug = FALSE
)
}
\arguments{
\item{text}{Character vector containing Markdown/HTML strings to draw.}

\item{x, y}{Unit objects specifying the location of the reference point.}

\item{hjust, vjust}{Numerical values specifying the justification
of the text boxes relative to \code{x} and \code{y}. These justification parameters
are specified in the internal reference frame of the text boxes, so that,
for example, \code{hjust} adjusts the vertical justification when the
text is rotated 90 degrees to the left or right.}

\item{halign, valign}{Numerical values specifying the text justification
inside the text boxes. If not specified, these default to \code{hjust} and
\code{vjust}.}

\item{rot}{Angle of rotation for text, in degrees.}

\item{default.units}{Units of \code{x} and \code{y} if these are provided only as
numerical values.}

\item{margin, padding}{Unit vectors of four elements each indicating the
margin and padding around each text label in the order top, right,
bottom, left. Margins are drawn outside the enclosing box (if any),
and padding is drawn inside. To avoid rendering artifacts, it is best
to specify these values in absolute units (such as points, mm, or inch)
rather than in relative units (such as npc).}

\item{r}{The radius of the rounded corners. To avoid rendering artifacts,
it is best to specify this in absolute units (such as points, mm, or inch)
rather than in relative units (such as npc).}

\item{align_widths, align_heights}{Should the widths and heights of all
the text boxes be aligned? Default is no.}

\item{name}{Name of the grob.}

\item{gp}{Other graphical parameters for drawing.}

\item{box_gp}{Graphical parameters for the enclosing box around each text label.}

\item{vp}{Viewport.}

\item{use_markdown}{Should the \code{text} input be treated as markdown? Default
is yes.}

\item{debug}{Should debugging info be drawn? Default is no.}
}
\value{
A grid \code{\link{grob}} that represents the formatted text.
}
\description{
This grob acts mostly as a drop-in replacement for \code{\link[grid:grid.text]{grid::textGrob()}}
but provides more sophisticated formatting. The grob can handle basic
markdown and HTML formatting directives, and it can also draw
boxes around each piece of text. Note that this grob \strong{does not} draw
\link{plotmath} expressions.
}
\examples{
library(grid)

text <- c(
  "Some text **in bold.**", "Linebreaks<br>Linebreaks<br>Linebreaks",
  "*x*<sup>2</sup> + 5*x* + *C*<sub>*i*</sub>",
  "Some <span style='color:blue'>blue text **in bold.**</span><br>And *italics text.*<br>
   And some <span style='font-size:18pt; color:black'>large</span> text."
)

x <- c(.2, .1, .7, .9)
y <- c(.8, .4, .1, .5)
rot <- c(0, 0, 45, -45)
gp = gpar(col = c("black", "red"), fontfamily = c("Palatino", "Courier", "Times", "Helvetica"))
box_gp = gpar(col = "black", fill = c("cornsilk", NA, "lightblue1", NA), lty = c(0, 1, 1, 1))
hjust <- c(0.5, 0, 0, 1)
vjust <- c(0.5, 1, 0, 0.5)

g <- richtext_grob(
  text, x, y, hjust = hjust, vjust = vjust, rot = rot,
  padding = unit(c(6, 6, 4, 6), "pt"),
  r = unit(c(0, 2, 4, 8), "pt"),
  gp = gp, box_gp = box_gp
)
grid.newpage()
grid.draw(g)
grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))

# multiple text labels with aligned boxes
text <- c("January", "February", "March", "April", "May")
x <- (1:5)/6 + 1/24
y <- rep(0.8, 5)
g <- richtext_grob(
  text, x, y, halign = 0, hjust = 1,
  rot = 45,
  padding = unit(c(3, 6, 1, 3), "pt"),
  r = unit(4, "pt"),
  align_widths = TRUE,
  box_gp = gpar(col = "black", fill = "cornsilk")
)
grid.newpage()
grid.draw(g)
grid.points(x, y, default.units = "npc", pch = 19, size = unit(5, "pt"))
}
\seealso{
\code{\link[=textbox_grob]{textbox_grob()}}
}
